//-------------------------------------------------------------------------------------------------
//         Определение переменных, используемых в тесте
//-------------------------------------------------------------------------------------------------
int8_t pinCnt,pinTst1,pinTst2,pinTst3; 
int8_t pinLed,pinBut, pinBlink,pinBlock;
int8_t pinADC, pinTCH,pinPWM,  pinDAC;
int8_t pinDHT,pinSR04,pinDS1820, pinSensX;
int8_t SPI_595,SPI_lcd,SPI_devX,SPI_devY;
int8_t i2c_lcd1,i2c_lcd2,i2c_X,i2c_Y;
int8_t i2c_mcp0,i2c_mcp1,i2c_pca,i2c_Z;
int8_t lcdPin6, lcdPin3;
//-------------------------------------------------------------------------------------------------
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//              Функция - установка номеров пинов под тип контроллера
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void setNumUserParam() {
#if defined(RT_HW_BOARD_AVR328)
pinCnt  =10;  pinTst1   =-1;  pinTst2   =-1;  pinTst3 =-1; 
pinLed  = 5;  pinBut    = 4;  pinBlock  = 8;  pinBlink= 9;
pinADC  =21;  pinPWM    = 6;  pinDAC    =-1;  pinTCH  =-1;    
pinSR04 = 2;  pinDHT    = 3;  pinDS1820 = 4;  pinSensX=-1;
SPI_595 =14;  SPI_lcd   =15;  SPI_devX  =16;  SPI_devY=17;
i2c_lcd1=39;  i2c_lcd2  =62;  i2c_X     =-1;  i2c_Y   =-1;
i2c_mcp0=32;  i2c_mcp1  =33;  i2c_pca   =40;  i2c_Z   =-1;
lcdPin6 =-1;  lcdPin3   =-1;
//---------------------------------------------------------------------------------------
#elif  defined(RT_HW_BOARD_MEGA2560)
pinCnt  =38;  pinTst1   =39;  pinTst2   =40;  pinTst3 =41; 
pinLed  =26;  pinBut    =27;  pinBlock  =28;  pinBlink=29;
pinADC  =54;  pinPWM    =45;  pinDAC    =-1;  pinTCH  =-1;    
pinSR04 = 2;  pinDHT    = 3;  pinDS1820 = 4;  pinSensX=-1;
SPI_595 =46;  SPI_lcd   =47;  SPI_devX  =48;  SPI_devY=49;
i2c_lcd1=39;  i2c_lcd2  =62;  i2c_X     =-1;  i2c_Y   =-1;
i2c_mcp0=32;  i2c_mcp1  =33;  i2c_pca   =40;  i2c_Z   =-1;
lcdPin6 =32;  lcdPin3   = 5;
//---------------------------------------------------------------------------------------
#elif  defined(RT_HW_BOARD_DUE)
pinCnt  =38;  pinTst1   =39;  pinTst2   =40;  pinTst3 =41; 
pinLed  =26;  pinBut    =27;  pinBlock  =28;  pinBlink=29;
pinADC  =54;  pinPWM    =45;  pinDAC    =67;  pinTCH  =-1;    
pinSR04 = 2;  pinDHT    = 3;  pinDS1820 = 4;  pinSensX=-1;
SPI_595 =46;  SPI_lcd   =47;  SPI_devX  =48;  SPI_devY=49;
i2c_lcd1=39;  i2c_lcd2  =62;  i2c_X     =-1;  i2c_Y   =-1;
i2c_mcp0=32;  i2c_mcp1  =33;  i2c_pca   =40;  i2c_Z   =-1;
lcdPin6 =32;  lcdPin3   = 5;
//---------------------------------------------------------------------------------------
#elif  defined(RT_HW_BOARD_ESP8266)
pinCnt  = 2;  pinTst1   = 0;  pinTst2   =-1;  pinTst3 =-1; 
pinLed  =12;  pinBut    =14;  pinBlock  =-1;  pinBlink=-1;
pinADC  =17;  pinPWM    =13;  pinDAC    =-1;  pinTCH  =-1;    
pinDHT  =-1;  pinSR04   =-1;  pinDS1820 =-1;  pinSensX=-1;
SPI_595 =-1;  SPI_lcd   =-1;  SPI_devX  =-1;  SPI_devY=-1;
i2c_lcd1=39;  i2c_lcd2  =62;  i2c_X     =-1;  i2c_Y   =-1;
i2c_mcp0=32;  i2c_mcp1  =33;  i2c_pca   =40;  i2c_Z   =-1;
lcdPin6 =-1;  lcdPin3   =-1;
//--------------------------------------------------------------------------------------- 
#elif  defined(RT_HW_BOARD_ESP32)
pinCnt  =13;  pinTst1   =12;  pinTst2   =14;  pinTst3 =27; 
pinLed  = 2;  pinBut    =15;  pinBlock  =27;  pinBlink=26;
pinADC  =54;  pinPWM    =45;  pinDAC    =-1;  pinTCH  =-1;    
pinDHT  = 6;  pinSR04   = 2;  pinDS1820 = 7;  pinSensX=-1;
SPI_595 =46;  SPI_lcd   =47;  SPI_devX  =48;  SPI_devY=49;
i2c_lcd1=39;  i2c_lcd2  =62;  i2c_X     =-1;  i2c_Y   =-1;
i2c_mcp0=32;  i2c_mcp1  =33;  i2c_pca   =40;  i2c_Z   =-1;
lcdPin6 =32;  lcdPin3   = 5;
//---------------------------------------------------------------------------------------  
#elif  defined(RT_HW_BOARD_STM32F103C)
pinCnt=15;    pinTst1=19;   pinTst2=20;   pinTst3=21; 
pinLed=16;    pinBut=17; 
pinADC= 0;    pinPWM=9;     pinDAC=-1;    pinTCH=-1;  
i2c_lcd1=63;
//---------------------------------------------------------------------------------------  
#elif  defined(RT_HW_BOARD_STM32F103R)
pinCnt=34;    pinTst1=35;   pinTst2=36;   pinTst3=37; 
pinLed=16;    pinBut=17;    
pinADC= 0;    pinPWM=33;    pinDAC=4;     pinTCH=-1;  
i2c_lcd1=63; 
//---------------------------------------------------------------------------------------  
#else 
//RT_HW_BOARD_ANON
pinCnt= -1;   pinTst1 = 9; pinTst2 =-1;   pinTst3 =-1;
#endif    //---------------------------------------------------------------------------------------
} //--END initParam()
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
