//-------------------------------------------------------------------------------------------------
//   Тест SDK для FLProg - библиотека RT_HW_BASE.h
//   Версия 2.1 31.08.2020
//   ecoins@mail.ru 
//-------------------------------------------------------------------------------------------------
#include  "RT_HW_BASE.h"
//-------------------------------------------------------------------------------------------------
//         Определение переменных, используемых в тесте
//-------------------------------------------------------------------------------------------------
uint8_t initParam = 0;                                //--Параметр для инициализации параметров
uint8_t numQuick, numFast, numSlow, numBack, numFrdm; //--Номера задач для диспетчера задач;
byte    pinControl,pinDebug1,pinDebug2,pinLed,pinButton,pinADC,pinPWM,pinDAC,pinTCH; 
bool    blink, headConsole, quickEvent, fastEvent;
uint8_t cntPrint;
uint8_t len; 
uint8_t qnt = 80;
//-------------------------------------------------------------------------------------------------
//   Cоздание строковых значений в PROGMEM
//-------------------------------------------------------------------------------------------------
const char headNameTest_PGM[] PROGMEM = "Тест RT_HW_Base.h"; 
const char pinsCnt_PGM[]      PROGMEM = "pins:control,debug1,debug2";
const char pinsLed_PGM[]      PROGMEM = "pins:led,button,PWM,ADC"; 
const char pinsDAC_PGM[]      PROGMEM = "pins:DAC,TCH";
const char headUserPins_PGM[] PROGMEM = "Пользовательские пины";
const char headBoardPins_PGM[]PROGMEM = "Пины и параметры контроллера"; 
const char head_scan_i2c_PGM[]PROGMEM = "Сканирование шины i2c";   
const char ADCx4_PGM[]        PROGMEM = "ADC.f,ADC.n,PWM,DAC";  
const char TCHx4_PGM[]        PROGMEM = "TCH.f,TCH.n,HALL.f,HALL.n"; 
//-------------------------------------------------------------------------------------------------
//   Объекты для работы с пинами
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_ID    idControl, idDebug1, idDebug2;
RT_HW_PIN_DOT_ID    idLed;
RT_HW_PIN_DIN_ID    idButton;
RT_HW_PIN_ADC_ID    idADC;
RT_HW_PIN_TCH_ID    idTCH;
RT_HW_PIN_HALL_ID   idHALL;
RT_HW_PIN_PWM_ID    idPWM;
RT_HW_PIN_DAC_ID    idDAC;
//=================================================================================================
void setup() {idLed.dir=0; idButton.dir=0; idADC.dir=0; idTCH.dir=0; idPWM.dir=0; idDAC.dir=0;}
//=================================================================================================
void loop() {
//-------------------------------------------------------------------------------------------------
//              УСТАНОВКА ПАРАМЕРОВ ->выполняется один раз
//-------------------------------------------------------------------------------------------------
if(initParam == 0) {initParam = 1;
pinControl=(uint8_t)RT_HW_PIN_CONTROL; pinDebug1=(uint8_t)RT_HW_PIN_DEBUG_1; pinDebug2=(uint8_t)RT_HW_PIN_DEBUG_2;
pinLed    =(uint8_t)RT_HW_PIN_LED;     pinButton=(uint8_t)RT_HW_PIN_BUTTON;  pinPWM=(uint8_t)RT_HW_PIN_PWM; pinADC=(uint8_t)RT_HW_PIN_ADC;     
pinDAC    =(uint8_t)RT_HW_PIN_DAC;     pinTCH   =(uint8_t)RT_HW_PIN_TCH;
}
//---------------------------------------------------------------------------------------------------
//            ДИСПЕТЧЕР И КОНСОЛЬ ->вызываются в каждом цикле loop()
//-------------------------------------------------------------------------------------------------
RT_HW_Base.sheduler();                                                //--Мини-диспетчер;
RT_HW_Base.printBegin(115200);   headConsole=RT_HW_Base.console.head; //--Подключение консоли;
//-------------------------------------------------------------------------------------------------
//          Настройка и вывод на тестовые пины  ->вызываются в каждом цикле loop()
//-------------------------------------------------------------------------------------------------
if(idControl.dir==0) {idControl.dir=7; if(idControl.mode==0){RT_HW_Base.directPinSetID(idControl,pinControl);if(bitRead(idControl.mode,RT_HW_PIN_KIND_DIR)){RT_HW_PIN_DIR_MODE_OUTPUT(idControl);} idControl.dir=1;}} 
if(idControl.dir==1) {RT_HW_PIN_DIR_WRITE(idControl, bitRead(RT_HW_Base.shed.blink,0));}

if(RT_HW_Base.shed.quick.num==1) {quickEvent=1;} else {quickEvent=0;}
if(idDebug1.dir==0) {idDebug1.dir=7;   if(idDebug1.mode==0) {RT_HW_Base.directPinSetID(idDebug1,pinDebug1);  if(bitRead(idDebug1.mode,RT_HW_PIN_KIND_DIR)) {RT_HW_PIN_DIR_MODE_OUTPUT(idDebug1);}  idDebug1.dir=1;}} 
if(idDebug1.dir==1) { RT_HW_PIN_DIR_WRITE(idDebug1,quickEvent);}

if(RT_HW_Base.shed.fast.num==1) {fastEvent=1;} else {fastEvent=0;}
if(idDebug2.dir==0) {idDebug2.dir=7;   if(idDebug2.mode==0) {RT_HW_Base.directPinSetID(idDebug2,pinDebug2);  if(bitRead(idDebug2.mode,RT_HW_PIN_KIND_DIR)) {RT_HW_PIN_DIR_MODE_OUTPUT(idDebug2);}  idDebug2.dir=1;}} 
if(idDebug2.dir==1) { RT_HW_PIN_DIR_WRITE(idDebug2, fastEvent);}
//-------------------------------------------------------------------------------------------------
//            ВЫВОД ЗАГОЛОВКОВ (однократный вывод после готовности консоли)
//-------------------------------------------------------------------------------------------------  
if (headConsole) {
RT_HW_Base.printTextPGM(headNameTest_PGM, 80, 'C', '=', 'Y'); //--Вывод заголовка из PROGMEM4;
RT_HW_Base.printHeadArchBoard();                              //--Вывод наименований и кодов платформы и контроллера;
RT_HW_Base.printTestPins();                                   //--Вывод номеров тестовых пинов;
RT_HW_Base.printHeadParamBoard();                             //--Вывод параметров контроллера;
RT_HW_Base.printTextPGM(headBoardPins_PGM,80,'C', '-', 'Y');  //--Вывод заголовка из PROGMEM
//RT_HW_Base.printHeadPinsCols();                             //--Вывод параметров пинов в форме колонок;
RT_HW_Base.printHeadPinsRows();                               //--Вывод параметров пинов в форме строк;
RT_HW_Base.printTextPGM(head_scan_i2c_PGM,80, 'C', '-', 'Y'); //--Вывод заголовка из PROGMEM;
RT_HW_Base.printHeadParamI2C();                               //--Вывод параметров i2c;
RT_HW_Base.printHeadScanI2C();                                //--Сканирование шины i2с;
RT_HW_Base.printTextPGM(headUserPins_PGM,80, 'C', '-', 'Y');  //--Вывод заголовка из PROGMEM;
RT_HW_Base.printTextPGM(pinsCnt_PGM,30, 'L', 's', ':'); RT_HW_Base.printDECx4(3,(int8_t)idControl.pin,(int8_t)idDebug1.pin, (int8_t)idDebug2.pin);             //--Вывод пинов;
RT_HW_Base.printTextPGM(pinsLed_PGM,30, 'L', 's', ':'); RT_HW_Base.printDECx4(4,(int8_t)pinLed,       (int8_t)pinButton,    (int8_t)pinPWM, (int8_t)pinADC);   //--Вывод пинов;
RT_HW_Base.printTextPGM(pinsDAC_PGM,30, 'L', 's', ':'); RT_HW_Base.printDECx4(2,(int8_t)pinDAC,       (int8_t)pinTCH);                                         //--Вывод пинов;
RT_HW_Base.printBlank(80, '=', 'Y');
RT_HW_Base.console.resetHead = 1;
}
//-------------------------------------------------------------------------------------------------
//          ОПЕРАТИВНАЯ ЗАДАЧА =1 (вызов 1 раз в 50ms) 
//-------------------------------------------------------------------------------------------------
if (RT_HW_Base.shed.quick.num == 1) {
RT_HW_Base.pinReadDIN (idButton,(int8_t)pinButton,'U','Y',5);     //--ТИП_ВХОДА, ИНВЕРСИЯ_ВХОДА, ВРЕМЯ_ЗАЩИТЫ_ОТ_ДРЕБЕЗГА_В_ТИКАХ_50_МС  
RT_HW_Base.pinWriteDOT(idLed,   (int8_t)pinLed, idButton.normal);  //--Вывод на пин дискретного вывода;
}
//-------------------------------------------------------------------------------------------------
//          БЫСТРАЯ  ЗАДАЧА =1 (вызов 1 раз в 100ms) 
//-------------------------------------------------------------------------------------------------
if (RT_HW_Base.shed.fast.num == 1) {
RT_HW_Base.pinReadADC(idADC,pinADC);                //--Чтение ADC;
RT_HW_Base.pinReadTCH(idTCH,pinTCH);                //--Чтение TCH  (ESP32);
RT_HW_Base.pinReadHALL(idHALL);                     //--Чтение HALL (ESP32);
RT_HW_Base.pinWritePWM(idPWM,pinPWM,idADC.normal);  //--Запись PWM;
RT_HW_Base.pinWriteDAC(idDAC,pinDAC,idADC.normal);  //--Запись DAC (DUE,ESP32,STM32F);
}
//-------------------------------------------------------------------------------------------------
//          МЕДЛЕННАЯ ЗАДАЧА =1 (вызов 1 раз в секунду) 
//-------------------------------------------------------------------------------------------------
if (RT_HW_Base.shed.slow.num == 1)  {;}
//-------------------------------------------------------------------------------------------------
//          МЕДЛЕННАЯ ЗАДАЧА =2 (вызов 1 раз в секунду)
//-------------------------------------------------------------------------------------------------
if (RT_HW_Base.shed.slow.num == 2) {   
RT_HW_Base.printTextPGM(ADCx4_PGM,25, 'L', 's', ':'); RT_HW_Base.printUintx4(4,idADC.filter, idADC.normal, idPWM.device, idDAC.device);  
if(RT_HW_ARCH_CODE == RT_HW_ID_ARCH_ESP32){
RT_HW_Base.printTextPGM(TCHx4_PGM,25, 'L', 's', ':'); RT_HW_Base.printDECx4(4,idTCH.filter, idTCH.normal, idHALL.device,idHALL.device); }
};
//-------------------------------------------------------------------------------------------------
} //--End loop;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-------------------------------------------------------------------------------------------------
//   Пример создания доступа к нескольким строкам из PROGMEM
//-------------------------------------------------------------------------------------------------
const char text0[]   PROGMEM = "FLProg 7.0.1"; 
const char text1[]   PROGMEM = "Arduino 1.8.12";
const char text2[]   PROGMEM = "RT_HW_Base 1.0"; 
const char text3[]   PROGMEM = "Проверка ARDUINO совместимости PROGMEM";
const char text4[]   PROGMEM = "Проверка FLPROG";
const char text5[]   PROGMEM = "Тестирование ARDUINO";  
const char text6[]   PROGMEM = "ARDUINO+FLPROG+KaScada+EIS=Успех"; 

const char* getNameStrPGM(uint8_t num = 0) {
if(num==0) {return text0;}
if(num==1) {return text1;}
if(num==2) {return text2;}
if(num==3) {return text3;}
if(num==4) {return text4;}
if(num==5) {return text5;}
if(num==6) {return text6;}
return text1;}
//==================================================================================================
