//*************************************************************************************************
//							1.Контроллер типа ESP32
//*************************************************************************************************
#if !defined(RT_HW_BOARD_SELECT) && (defined(RT_HW_BOARD_ESP32_DEV)	          ||\
									 defined(RT_HW_BOARD_ESP32_LOLIN_D32)     ||\
									 defined(RT_HW_BOARD_ESP32_LOLIN_D32_PRO) ||\
									 defined(RT_HW_BOARD_ESP32_M5_STACK_CORE) ||\
									 defined(RT_HW_BOARD_ESP32_D1_MINI_32))
#define 	 RT_HW_BOARD_SELECT	 "Board Select->ESP32 Dev,Wrover,Lolin,Wemos D1...M5Stack..." //--Идентификатор выбора
#define  	 RT_HW_BRD_ESP32                            		//--Идентификатор выбора пинов и параметров; 
//------Параметры контроллера общие-------------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=40,	RT_HW_FCPU=240, 	RT_HW_VCC=3300}; 
//-----Параметры UART------------------------------------------------------------------------------	
enum   {RT_HW_UART0_RX=3,   RT_HW_UART0_TX=1,
		RT_HW_UART1_RX=-1,  RT_HW_UART1_TX=-1,  RT_HW_UART2_RX=16, RT_HW_UART2_TX=17};
#define RT_HW_PERMIT_UART0
#define RT_HW_PERMIT_UART2
//-----Параметры I2C------------------------------------------------------------------------------	
enum   {RT_HW_I2C0_SDA=22,  RT_HW_I2C0_SCL=21,  RT_HW_I2C0_MODE_FM=RT_HW_I2C_MODE_FM}; 
#define RT_HW_PERMIT_I2C0		
//-----Параметры SPI------------------------------------------------------------------------------	
enum   {RT_HW_SPI0_SS=5,  RT_HW_SPI0_MOSI=23,  RT_HW_SPI0_MISO=19,  RT_HW_SPI0_SCK=18,
        RT_HW_SPI1_SS=15, RT_HW_SPI1_MOSI=13,  RT_HW_SPI1_MISO=12,  RT_HW_SPI1_SCK=14};
#define RT_HW_PERMIT_SPI0
#define RT_HW_PERMIT_SPI1
//-----Системные параметры-------------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PAR) ={12,			   	RT_HW_PGM_END};  //--SYS->depth;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PIN) ={RT_HW_BOARD_CONTROL, RT_HW_BOARD_LED, RT_HW_BOARD_BUTTON, RT_HW_PGM_END}; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_ADC) ={12,7,9,			RT_HW_PGM_END};  //--ADC->depth,drift,null;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_TCH) ={8,  				RT_HW_PGM_END};  //--TCH->depth,drift,null; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PWM) ={12,10,			RT_HW_PGM_END};  //--PWM->depth,freq; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_DAC) ={8,				RT_HW_PGM_END};  //--DAC->depth; 
//-----Системные пины и параметры коммуникаций------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_I2C)	={RT_HW_I2C0_SDA, RT_HW_I2C0_SCL,  RT_HW_PGM_END}; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_SPI)	={RT_HW_SPI0_SS,  RT_HW_SPI0_MOSI, RT_HW_SPI0_MISO, RT_HW_SPI0_SCK,
                                          RT_HW_SPI1_SS,  RT_HW_SPI1_MOSI, RT_HW_SPI1_MISO, RT_HW_SPI1_SCK, RT_HW_PGM_END};  
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_UHS)	={RT_HW_UART0_RX, RT_HW_UART0_TX,
		                                  RT_HW_UART1_RX, RT_HW_UART1_TX,
										  RT_HW_UART2_RX, RT_HW_UART2_TX,   RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_USS)	={				 					RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_CAN)	={				 		    		RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_BTH)	={'B','L','E',				 		RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ETH)	={  								RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_WFI)	={(int8_t)192,  					RT_HW_PGM_END};
//-----Доступные пины контроллера------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ALL)	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										  20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DIN)	={ 0, 1, 2, 3, 4, 5,-1,-1,-1,-1,-1,-1,12,13,14,15,16,17,18,19,
										  20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ADC)	={36,37,38,39,32,33,34,35, 0, 2,15,13,12,14,27,25,26,		  RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_TCH)	={ 4, 0, 2,15,13,12,14,27,33,32,							  RT_HW_PGM_END};									
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DOT)	={ 0, 1, 2, 3, 4, 5,-1,-1,-1,-1,-1,-1,12,13,14,15,16,17,18,19,
										  20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,-1,-1,-1,-1,-1,RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_PWM)	={ 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,44,45,46,				  RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DAC)	={25,26,													  RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_INT)	={ 0, 1, 2, 3, 4, 5,-1,-1,-1,-1,-1,-1,12,13,14,15,16,17,18,19,
										  20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_N5V)	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										  20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,RT_HW_PGM_END};	
//-----Тестовые пины и адреса------------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DBG) ={					RT_HW_PGM_END};	// debug1,debug2,debug3;	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_OUT)	={ 4,		  		RT_HW_PGM_END};	// PWM0, PWM1, led, dev;							                  
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_INP)	={36,37,15,		    RT_HW_PGM_END};	// A0,   A1, btn1,btn2;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DCT)	={25,-1,33,         RT_HW_PGM_END};	// DAC0,DAC1,TCH0;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DEV)	={-1,26, 	 		RT_HW_PGM_END};	// DS1820,DHT22,HC-SR04
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_CSS)	={13,14,27,			RT_HW_PGM_END};	// CS SPI:595,LCD,NRF,DEVl 	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_LC6) ={					RT_HW_PGM_END};	// Пины для подключения LCD по 4-х битной шине;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_SSP) ={					RT_HW_PGM_END};	// Пины программного SPI;	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_ADR_I2C) ={39,62,32,33,		RT_HW_PGM_END};	// lcd1,lcd2,mcp1,mcp2;
//-------------------------------------------------------------------------------------------------
#endif
//*************************************************************************************************
