//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Структура для преобразования числа в символы
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct RT_HW_BASE_VAL_ID {uint32_t val; uint16_t len:4,index:4,num:4,mess:4; uint8_t mode:2,minus:1,point:2,pnt:1;};	


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.Структуры для планирования задач
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-----ДИСПЕТЧЕР ЗАДАЧ-----------------------------------------------------------------------------
struct RT_HW_STRUCT_SHAD  	{uint8_t  num,cnt,qnt;};	//--Регистры диспетчера;
struct RT_HW_STRUCT_SHED  	{RT_HW_STRUCT_SHAD quick, fast, slow, back, frdm;  uint32_t timeStart10, timeStart25;
							 uint8_t gen250; uint8_t blink; uint8_t run; uint8_t cnt50:1, cnt100:3, cnt250:4;};  
//-----ДЕЛИТЕЛЬ СОБЫТИЙ----------------------------------------------------------------------------							 
struct RT_HW_DIVIDE_EVENT{uint8_t cnt; uint8_t state=0;};	//--Биты state: 0-инициализация, 1-event, 2-blink(меандр);						 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						2.Структуры системных параметров
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++					   
struct RT_HW_STRUCT_PIN   	{int8_t   control,led,button;};					//--Структура для пинов платы; 
struct RT_HW_STRUCT_DEPTH 	{uint8_t  sys,adc,pwm,dac,tch,vNull,drift;}; 	//--Разрешения устройств и дрейфы ADC; 
struct RT_HW_STRUCT_PWM   	{uint16_t channel; uint16_t freq;};				//--PWM; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						3.Структуры работы с UART
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
struct RT_HW_STRUCT_UART  	{uint16_t  begin, ready;
#if defined(RT_HW_ARCH_STM32) || defined(RT_HW_ARCH_SEEEDUINO)
uint32_t timeStart; uint16_t dir0;
#endif
};	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						4.Структуры работы с i2с
//	RT_HW_STRUCT_I2C 		- данные 
//  RT_HW_STRUCT_FIND_I2C	- структура для поиска устройства на щине i2c; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct RT_HW_STRUCT_I2C   	{int8_t   sda,scl,adr; uint8_t state; uint8_t speed; uint16_t freq;}; 
struct RT_HW_STRUCT_FIND_I2C{uint8_t custom=0; uint8_t maxErr=20; uint8_t cntErr=0; uint8_t maxOk:4, cntOk:4; uint32_t timeDelay;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						5.Структуры работы с SPI
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
struct RT_HW_STRUCT_SPI   	{int8_t   ss,mosi,miso,sck; char mode; uint16_t freq;};	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						6.Структуры работы с консолью
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
struct RT_HW_STRUCT_CONSOLE {uint8_t dir;     uint8_t cnt:4, ready:1, head:1, resetHead:1, mess:1; 
					         uint8_t numUart; uint8_t buff;};	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						10.Обощенная структура для работы с устройствами контроллера
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
struct RT_HW_STRUCT_DEVICE{
RT_HW_STRUCT_PIN  	pin;	//--Данные для работы с системными пинами control,led;
RT_HW_STRUCT_DEPTH	depth;	//--Данные для работы с разрядностью (разрешениями) устройств;
RT_HW_STRUCT_PWM 	pwm;	//--Данные для работы с PWM;
RT_HW_STRUCT_UART 	uart; 	//--Данные для работы с UART;
//-----Шина i2c------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C0)			  
RT_HW_STRUCT_I2C 	i2c0;	//--Данные для работы с шиной i2c0;
#endif		  
#if defined(RT_HW_PERMIT_I2C1)			  
RT_HW_STRUCT_I2C 	i2c1;	//--Данные для работы с шиной i2c1;	
#endif
#if defined(RT_HW_PERMIT_I2C2)			  
RT_HW_STRUCT_I2C 	i2c2;	//--Данные для работы с шиной i2c2;
#endif
//-----Шина SPI------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI0)			  
RT_HW_STRUCT_SPI 	spi0;	//--Данные для работы с SPI0;
#endif		  
#if defined(RT_HW_PERMIT_SPI1)			  
RT_HW_STRUCT_SPI 	spi1;	//--Данные для работы с SPI1;	
#endif
#if defined(RT_HW_PERMIT_SPI2)			  
RT_HW_STRUCT_SPI 	spi2;	//--Данные для работы с SPI2;
#endif			  
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



