#include "RT_HW_BASE.h"
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  	Конструктор
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RT_HW_BASE:: RT_HW_BASE(){//console.dir=0; console.begin=console.ready=console.head=console.mess=0; 
//-------------------------------------------------------------------------------------------------
//			Настройка диспетчера задач
//-------------------------------------------------------------------------------------------------
shed.cnt50=shed.cnt100=shed.cnt250=shed.gen250=0;
shed.quick.cnt=shed.fast.cnt=shed.slow.cnt=shed.back.cnt=shed.frdm.cnt=0;
shed.quick.qnt=5; 							//--Кол-во срочных   задач (период  10мс);
shed.fast.qnt=4;							//--Кол-во быстрых   задач (период  25мс);
shed.slow.qnt=4; 							//--Кол-во медленных задач (период 250мс);
shed.back.qnt=5;   							//--Кол-во фоновых   задач (период 100мс);
shed.frdm.qnt=20; 							//--Кол-во свободных задач (период loop()-когда нет вызванных задач);
shed.run=0;									//--Флаги разрешения запусков задач(quick,fast,slow,back,frdm);
//-------------------------------------------------------------------------------------------------
//			Настройка рабочих регистров для работы с пинами
//-------------------------------------------------------------------------------------------------
device.pin.control	 = getIntPGM (RT_HW_PGM_SYS_PIN_ID, 0);	//--Пин контрольного светодиода; 
device.pin.led	 	 = getIntPGM (RT_HW_PGM_SYS_PIN_ID, 1);	//--Пин светодиода на плате;
device.pin.button	 = getIntPGM (RT_HW_PGM_SYS_PIN_ID, 2);	//--Пин кнопки на плате; 
device.depth.sys	 = getUintPGM(RT_HW_PGM_SYS_PAR_ID, 0);	//--Cистемное разрешение (8,10,12,16); 
device.depth.adc	 = getUintPGM(RT_HW_PGM_SYS_ADC_ID, 0); //--Разрешение ADC;
device.depth.drift	 = getUintPGM(RT_HW_PGM_SYS_ADC_ID,	1); //--Допустимый дрейф показаний ADC;
device.depth.vNull	 = getUintPGM(RT_HW_PGM_SYS_ADC_ID, 2); //--Допустимый дрейф нуля ADC;
device.depth.tch	 = getUintPGM(RT_HW_PGM_SYS_TCH_ID, 0);	//--Разрешение TCH (ESP32);
device.depth.pwm	 = getUintPGM(RT_HW_PGM_SYS_PWM_ID, 0);	//--Разрешение PWM; 
device.depth.dac	 = getUintPGM(RT_HW_PGM_SYS_DAC_ID, 0); //--Разрешение DAC;			 
//-----Настройка разрядности ADC и PWM для контроллера SAM3X8E (Arduino DUE)-----------------------
#if defined(RT_HW_ARCH_SAM3) 
	analogReadResolution(device.depth.adc);	//--ADC; 
	analogWriteResolution(device.depth.pwm);//--PWM; 
#endif 
//-----Настройка разрядности ADC и PWM для контроллеров SEEEDUINO (Arduino DUE)-----------------------
#if defined(RT_HW_ARCH_SEEEDUINO) 
	analogReadResolution(device.depth.adc);	//--ADC; 
	analogWriteResolution(device.depth.pwm);//--PWM; 
#endif 
//-----Настройка разрядности ADC и PWM для контроллеров STM32--------------------------------------- 
#if defined(RT_HW_ARCH_STM32) && defined(RT_HW_ARCH_STM32DUINO)
	analogReadResolution (device.depth.adc);//--ADC; 
	analogWriteResolution(device.depth.pwm);//--PWM; 
#endif 
//-----Разрешение использование выводов JTDI,JTDO,JRST(PA15,PB3,PB4) как GPIO----------------------
#if defined(RT_HW_DISABLE_JTAG_PINS)	//--Устанавливается  в файле DEFINED_BOARD;
	afio_cfg_debug_ports(AFIO_DEBUG_SW_ONLY);	
#endif
//-------------------------------------------------------------------------------------------------
//			Установка параметров UART
//-------------------------------------------------------------------------------------------------
console.numUart=0; 
device.uart.begin=device.uart.ready=0; 
//-------------------------------------------------------------------------------------------------
//			Установка параметров i2c
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C0)								
device.i2c0.adr	 	= 0;	//--адрес; 
device.i2c0.sda	 	= getIntPGM(RT_HW_PGM_PIN_I2C_ID,0);	//--SDA; 
device.i2c0.scl		= getIntPGM(RT_HW_PGM_PIN_I2C_ID,1);	//--SCL; 
device.i2c0.speed	= RT_HW_I2C0_MODE_FM;					//--код частоты i2c;
device.i2c0.state=0;	
#endif
#if defined(RT_HW_PERMIT_I2C1)
device.i2c1.adr	 	= 0;									//--адрес; 
device.i2c1.sda	 	= getIntPGM(RT_HW_PGM_PIN_I2C_ID,2);	//--SDA; 
device.i2c1.scl		= getIntPGM(RT_HW_PGM_PIN_I2C_ID,3);	//--SCL; 
device.i2c1.speed	= RT_HW_I2C1_MODE_FM;;	//--код частоты i2c;
device.i2c1.state=0;	
#endif
#if defined(RT_HW_PERMIT_I2C2)
device.i2c2.adr	 	= 0;									//--адрес; 
device.i2c2.sda	 	= getIntPGM(RT_HW_PGM_PIN_I2C_ID,4);	//--SDA; 
device.i2c2.scl		= getIntPGM(RT_HW_PGM_PIN_I2C_ID,5);	//--SCL; 
device.i2c2.speed	= RT_HW_I2C2_MODE_FM;					//--код частоты i2c;
device.i2c2.state=0;	
#endif
//-------------------------------------------------------------------------------------------------
};					
//---------------------------------------------------------------------------------------		
RT_HW_BASE RT_HW_Base;//--Создание внешнего объекта	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++