#include "RT_HW_BASE.h"	 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					12.1. Настройка пина на выбранный режим работы
//   RT_HW_PGM_PIN_ALL_ID,	RT_HW_PGM_PIN_DIN_ID,	RT_HW_PGM_PIN_ADC_ID,	RT_HW_PGM_PIN_TCH_ID,
//	 RT_HW_PGM_PIN_DOT_ID,	RT_HW_PGM_PIN_PWM_ID,	RT_HW_PGM_PIN_DAC_ID,	RT_HW_PGM_PIN_INT_ID, 
//	 RT_HW_PGM_PIN_N5V_ID,
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void RT_HW_BASE:: setPinID(RT_HW_PIN_DIR_ID &id, int8_t pin, uint8_t kind, char mode, uint16_t freq){
if( id.dir==0){if(pin<0) {id.dir=7; return;}}
id.pin=pin;
//-------------------------------------------------------------------------------------------------
//		Дискретный вход
// mode: 'U'     - дискретный вход с подтяжкой к +Vcc;
//		 'D'     - дискретный вход с подтяжкой к +Gnd;
// 		 'I','F',любой другой символ - дискретный вход обычный;
//-------------------------------------------------------------------------------------------------
if((id.dir==0) && (kind==RT_HW_PGM_PIN_DIN_ID)){
	if(!checkPinPGM(     RT_HW_PGM_PIN_DIN_ID,pin)) {id.dir=10; return;} 	//--Проверка на допустимость дискретного ввода;  
	RT_HW_PIN_DIR_SET_ID(id,pin); 											//--Сохранение параметров пина;
	if(mode=='I') {id.dir=1; pinMode(pin, RT_HW_PIN_MODE_INPUT);}			//--Дискретный вход обычный;
	if(mode=='U') {id.dir=1; pinMode(pin, RT_HW_PIN_MODE_INPUT_PULLUP);}	//--Дискретный вход с подтяжкой к +Vcc;
	if(mode=='D') {id.dir=1; pinMode(pin, RT_HW_PIN_MODE_INPUT_PULLDOWN);}	//--Дискретный вход с подтяжкой к Gnd;
	if(mode=='F') {id.dir=1; pinMode(pin, RT_HW_PIN_MODE_INPUT);}			//--Дискретный вход - аналог INPUT; 
	if(id.dir!=1) {id.dir=1; pinMode(pin, RT_HW_PIN_MODE_INPUT);}			//--Дискретный вход - аналог INPUT; 
	return;}
//-------------------------------------------------------------------------------------------------	
//		Аналоговый вход
//-------------------------------------------------------------------------------------------------
if((id.dir==0) && (kind==RT_HW_PGM_PIN_ADC_ID)){
	if(!checkPinPGM(	 RT_HW_PGM_PIN_ADC_ID,pin)) {id.dir=20; return;} 	//--Проверка на допустимость аналового ввода; 
	RT_HW_PIN_DIR_SET_ID(id,pin); 											//--Сохранение параметров пина;			
	pinMode(id.pin, RT_HW_PIN_MODE_INPUT_ANALOG);							//--Настройка пина;
	id.dir=1; return;}
//-------------------------------------------------------------------------------------------------	
//		Сенсорный вход (ESP32)
//-------------------------------------------------------------------------------------------------
if((id.dir==0) && (kind==RT_HW_PGM_PIN_TCH_ID)){	
#if  defined(RT_HW_ARCH_ESP32) 	
	if(!checkPinPGM(	 RT_HW_PGM_PIN_TCH_ID,pin)) {id.dir=30; return;} 		//--Проверка на допустимость аналового ввода; 
	pinMode(pin,RT_HW_PIN_MODE_INPUT);
	id.dir=1; return;
#endif
	id.dir=31; return;};
//-------------------------------------------------------------------------------------------------	
//		Дискретный вывод
//-------------------------------------------------------------------------------------------------	
if((id.dir==0) && (kind==RT_HW_PGM_PIN_DOT_ID)){
	if(!checkPinPGM(	 RT_HW_PGM_PIN_DOT_ID,pin)) {id.dir=40; return;}			//--Проверка на допустимость аналового ввода; 
	RT_HW_PIN_DIR_SET_ID(id,pin); 		//--Сохранение параметров пина (пин, регистр, доступ к биту в регистре и т.п.);
	if(mode=='O') {id.dir=1; pinMode(pin, RT_HW_PIN_MODE_OUTPUT_OPEN_DRAIN);} 
	if(id.dir!=1) {id.dir=1; pinMode(pin, RT_HW_PIN_MODE_OUTPUT);} 	 
	return;}
//-------------------------------------------------------------------------------------------------
//		Запись PWM
//-------------------------------------------------------------------------------------------------	
if((id.dir==0) && (kind==RT_HW_PGM_PIN_PWM_ID)){
	if(!checkPinPGM(	 RT_HW_PGM_PIN_PWM_ID,pin)) {id.dir=50; return;}			//--Проверка на допустимость аналового ввода; 
#if defined(RT_HW_ARCH_AVR) || defined(RT_HW_ARCH_SAM3)
	id.dir=1; return;
#endif	
//-----------------------------------------------------------------------------
#if defined(RT_HW_ARCH_ESP8266) 	
	pinMode(pin,RT_HW_PIN_MODE_OUTPUT); id.dir=1; return;
#endif				
//-----------------------------------------------------------------------------		
#if  defined(RT_HW_ARCH_ESP32) 
int16_t buff=getFistBitUint16(device.pwm.channel);		//--Получение номера свободного каналов PWM;
if(buff<0)	{id.dir=52; return;} 						//--Если все каналы заняты(num<0), выход со сбросом флага id.ok;
id.num=buff; bitSet(device.pwm.channel,id.num);    		//--Установка номера и флага занятости канала;
id.freq=freq;											//--
ledcSetup(id.num,constrain(id.freq,100,40000),device.depth.pwm);//--Настройка канала id.channel: частота и разрешение;
ledcAttachPin(pin,id.num);			    				//--Настройка ШИМ ;
//buff=normPWM(val); ledcWrite(id.num,buff);			//--Вывод ШИМ;
id.dir=1;	return;
#endif
//-----------------------------------------------------------------------------
#if defined(RT_HW_ARCH_STM32) 
	if(mode=='O') {pinMode(id.pin, RT_HW_PIN_MODE_OUTPUT_PWM_OPEN_DRAIN);} 
	else          {pinMode(id.pin, RT_HW_PIN_MODE_OUTPUT_PWM);}
    id.dir=1; return;	//--Вывод ШИМ;	
#endif
	id.dir=51; return;
	}
//-------------------------------------------------------------------------------------------------	
//		Аналоговый вывод
//-------------------------------------------------------------------------------------------------	
if((id.dir==0) && (kind==RT_HW_PGM_PIN_DAC_ID)){
	if(!checkPinPGM(	 RT_HW_PGM_PIN_DAC_ID,pin)) {id.dir=60; return;}			//--Проверка на допустимость аналового ввода; 
	id.dir=1; return;}	
//-------------------------------------------------------------------------------------------------
//		Неопознанный тип устройства
//-------------------------------------------------------------------------------------------------
id.dir=7; return;
};	
//==================================================================================================	


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					ДИСКРЕТНЫЙ ВВОД (предварительно вызывается  setPinID());
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
bool RT_HW_BASE:: pinDigitalRead(RT_HW_PIN_DIR_ID &id){if(id.dir==1) {return RT_HW_PIN_DIR_READ(id);} return 0;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					Аналоговый ВВОД (предварительно вызывается  setPinID());
// mode: 'D' -возвращает значение непосредственно с устройства ADC (с разрядностью ADC устройства);
//		 'N' -возвращает нормализованное до системной разрядности (device.sys.depth) значение с ADC;
//		 'F' -возвращает нормализованное до системной разрядности (device.sys.depth) значение с ADC
//			  с фильтрацией дрейфа показаний(device.adc.drift) и дрейфа нуля (device.adc.vNull);
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint16_t RT_HW_BASE:: pinAnalogRead(RT_HW_PIN_DIR_ID &id, uint16_t &ago, char mode){if(id.dir==1) {uint16_t m16, dv; int32_t filter=0;
	m16=maxBitDepth(device.depth.adc); 		//--Получение максимального значения для ADC 
	dv=analogRead(id.pin); 					//--Чтение значения ADC;
	if(dv>m16) {dv=m16;}					//--Ограничение показания ADC сверху;
	if(mode=='D') {return dv;}				//--Возвращение значение ADC с устройства;
	if(mode=='N') {return normADC(dv);}		//--Возвращение нормализованного значения ADC;	
	//-------------------------------------------
	filter=makeDelta(ago, dv, device.depth.drift); //--Гистерезис
	if(filter>m16) {filter=m16;} 
	if((m16-filter)<device.depth.drift) {filter=m16;}
	if(filter<device.depth.vNull) {filter=0;}
	ago=filter;
	return normADC(filter);						//--Возвращает нормализованное значение ADC с фильтрацией;
}return 0;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					СЕНСОРНЫЙ ВВОД (предварительно вызывается  setPinID());
// mode: 'D' -возвращает значение непосредственно с устройства ADC (с разрядностью ADC устройства);
//		 'N' -возвращает нормализованное до системной разрядности (device.sys.depth) значение с ADC;
//		 'F' -возвращает нормализованное до системной разрядности (device.sys.depth) значение с ADC
//			  с фильтрацией дрейфа показаний(device.adc.drift) и дрейфа нуля (device.adc.vNull);
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint16_t RT_HW_BASE:: pinTouchRead(RT_HW_PIN_DIR_ID &id, char mode){if(id.dir==1){
#if defined(ESP32)
	uint16_t dv;
	dv=touchRead(id.pin);
	if(mode=='D') {return dv;} 
	if(mode=='N') {return dv;} 
	if(mode=='F') {return dv;} 
	return 0;
#endif
} return 0;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					ЧТЕНИЕ ВСТРОЕННОГО ДАТЧИКА ХОЛЛА [ESP32]
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int16_t RT_HW_BASE:: pinReadHALL(){
#if  defined(RT_HW_ARCH_ESP32) 
	return hallRead();
#endif	
return 0;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					ДИСКРЕТНЫЙ ВЫВОД (предварительно вызывается  setPinID());
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void RT_HW_BASE:: pinDigitalWrite(RT_HW_PIN_DIR_ID &id, uint8_t val){if(id.dir==1) {RT_HW_PIN_DIR_WRITE(id,val);}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					ШИМ ВЫВОД  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint16_t RT_HW_BASE:: pinWritePWM (RT_HW_PIN_DIR_ID &id, uint16_t val, uint16_t freq, char mode){
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_ARCH_AVR) || defined(RT_HW_ARCH_SAM3)
if(id.dir==1) {uint16_t buff=normPWM(val); analogWrite(id.pin,buff); return buff;}	//--Вывод;	
#endif
//-------------------------------------------------------------------------------------------------
#if 	defined(RT_HW_ARCH_ESP8266) 	 
if(id.dir==1) {//analogWriteFreq(constrain(freq, 100,10000)); 						//--Настройка;
              uint16_t buff=normPWM(val); analogWrite(id.pin,buff);	return buff;}	//--Вывод;   	
#endif
//-------------------------------------------------------------------------------------------------		
#if  defined(RT_HW_ARCH_ESP32) 
if(id.dir==1){uint16_t buff=normPWM(val); ledcWrite(id.num,buff); return buff;}		//--Вывод;
#endif
//------------------------------------------------------------------------------------------------
#if defined(RT_HW_ARCH_STM32) 
if(id.dir==1){uint16_t buff=normPWM(val);  pwmWrite(id.pin,buff); return buff;}	//--Вывод;	
#endif
//-----------------------------------------------------------------------------
return 0;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					ВЫВОД DAC
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint16_t RT_HW_BASE:: pinWriteDAC(RT_HW_PIN_DIR_ID &id, uint16_t val){
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_ARCH_SAM3) || defined(RT_HW_ARCH_SEEEDUINO)
if(id.dir==1) {uint16_t buff=normDAC(val); analogWrite(id.pin,buff);	return buff;}
#endif
//-------------------------------------------------------------------------------------------------		
#if  defined(RT_HW_ARCH_ESP32)  
if(id.dir==1) {uint16_t buff=normDAC(val); dacWrite(id.pin,buff);		return buff;}
#endif
//-------------------------------------------------------------------------------------------------
#if 	defined(RT_HW_ARCH_STM32) 
if(id.dir==1) {uint16_t buff=normDAC(val);  
			   //analogWrite(id.pin,buff);
																	return buff;};		
#endif
//-------------------------------------------------------------------------------------------------
return 0;};
//=================================================================================================







/*
void RT_HW_BASE:: directPinDigitalWrite(RT_HW_PIN_DIR_ID &id, int8_t pin, uint8_t val){
if(id.dir==1) {RT_HW_PIN_DIR_WRITE(id,val); return;}
if(id.dir==2) {digitalWrite(id.pin,val); 	return;}
if(id.dir==7) {return;}
if(id.dir==0) {
			  // id.mode=getModePin(pin);
			   //if(!bitRead(id.mode,RT_HW_PIN_INIT_MODE)){id.mode=getModePin(pin);}	//--Если свойства не определены, определить их в id.mode)
			   //f(!bitRead(id.mode,RT_HW_PIN_KIND_DIR))	{id.dir=7; return;} 		//--Если пин без свойства DIR, то выход;
			  // RT_HW_PIN_DIR_SET_ID(id,pin);  										//--Установка параметров id; 
			  // RT_HW_PIN_DIR_MODE_OUTPUT(id);										//--Настройка пина на выход;
			  // RT_HW_PIN_DIR_WRITE(id,val);											//--Первоначальный вывод на пин;
			   id.dir=2;}															//--Переход на рабочий режим;
};
*/
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					3. Работа с пинами через функции Arduino
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  3.1.Дискретное чтение с пина
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//void RT_HW_BASE:: pinReadDIN(RT_HW_PIN_DIN_ID &id, int8_t pin, char spec, char inv, uint8_t periodRattigTick50){
/*
if(id.dir==0) {uint16_t mode=getModePin(pin); 
			   if(bitRead(mode,RT_HW_PIN_KIND_DIN) && ((spec=='I') || (spec=='U') || (spec=='D') || (spec=='F'))){
				if(spec=='I') {pinMode(pin, RT_HW_PIN_MODE_INPUT);}			//--дискретный вход обычный;
				if(spec=='U') {pinMode(pin, RT_HW_PIN_MODE_INPUT_PULLUP);}	//--дискретный вход с подтяжкой к +Vcc;
				if(spec=='D') {pinMode(pin, RT_HW_PIN_MODE_INPUT_PULLDOWN);}//--с подтяжкой к Gnd;											
				if(spec=='F') {pinMode(pin, RT_HW_PIN_MODE_INPUT);}			//--дискретный вход - аналог INPUT; 	
				id.device=id.filter=digitalRead(pin); 
				if(inv=='Y') {id.normal=!id.filter;} else {id.normal=id.filter;};
				if(periodRattigTick50){id.dir=2;}    else {id.dir=1;}}
			   else {id.normal=id.device=id.filter=0;      id.dir=7;}
			   }
//-------------------------------------------------------------------------------------------------
if(id.dir==1) {id.device=id.filter=digitalRead(pin); if(inv=='Y') {id.normal=!id.filter;} else {id.normal=id.filter;};}	 //--Чтение без защиты от дребезга;
//-------------------------------------------------------------------------------------------------
if(id.dir==2){id.device=digitalRead(pin); id.curBlink=bitRead(shed.blink,3); //--Сохраняем текущее значение пина и blink=50ms;
if(!id.step) {if(id.ago==id.device) {id.filter=id.device;} else {id.cnt=0; id.agoBlink=id.curBlink; id.step=1;}}
if(id.step)  {if(id.ago==id.device) {id.filter=id.device; id.step=0;} else {if(id.agoBlink!=id.curBlink) {
				id.agoBlink=id.curBlink; if(++id.cnt>=periodRattigTick50) {id.ago=id.filter=id.device; id.step=0;}}}}
			  if(inv=='Y') {id.normal=!id.filter;} else {id.normal=id.filter;};}
//-------------------------------------------------------------------------------------------------
*/
//}; //--Завершение обработки;

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					3.3.Аналоговое чтение с пина 
//(id.sensor-сенсор, id.filter-отфильтрованный id.sensor, id.normal-нормализованный id.filter)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//void RT_HW_BASE:: pinReadADC(RT_HW_PIN_ADC_ID &id, int8_t pin){
/*
if(id.dir==0){uint16_t mode=getModePin(pin); if(!bitRead(mode,RT_HW_PIN_KIND_ADC)) { id.dir=7; id.device=id.filter=id.normal=0; return;}
#if defined(RT_HW_ARCH_STM32F1) ||  defined(RT_HW_ARCH_STM32F4) || defined(RT_HW_ARCH_STM32H7)			
			pinMode(pin,INPUT_ANALOG);
#endif	
			id.dir=1;}		
if(id.dir==1) {uint16_t m16=maxBitDepth(device.depth.adc); 	
			id.device=analogRead(pin); 
			if(id.device>m16) {id.device=m16;} //--Сохраняем в буфере максимальное для ADC значение;
			id.filter=makeDelta(id.filter,id.device,device.depth.adcDrift); if(id.filter>m16) {id.filter=m16;} 
			if((m16-id.filter)<device.depth.adcDrift) {id.filter=m16;}
			if(id.filter<device.depth.adcNull) {id.filter=0;}	
			id.normal=normADC(id.filter);	
			}		
*/			
//};	 									 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  ЧТЕНИЕ С СЕНСОРНОГО ПИНА
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//void RT_HW_BASE:: pinReadTCH(RT_HW_PIN_TCH_ID &id, int8_t pin){
/*
#if  defined(RT_HW_ARCH_ESP32) 
if(id.dir==0) {uint16_t mode=getModePin(pin); if(!bitRead(mode,RT_HW_PIN_KIND_TCH)) {id.dir=7; return;} pinMode(pin,RT_HW_PIN_MODE_INPUT);id.dir=1;}		
if(id.dir==1) {id.device=id.filter=id.normal=touchRead(pin);
}		
#else 
id.dir=pin=-1; id.device=id.filter=id.normal=0;
#endif  
*/
//};

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					ЧТЕНИЕ ВСТРОЕННОГО ДАТЧИКА ХОЛЛА [ESP32]
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
void  RT_HW_BASE:: pinReadHALL(RT_HW_PIN_HALL_ID &id){
#if  defined(RT_HW_ARCH_ESP32) 
if(id.dir==0) {id.device=id.filter=id.normal=0; id.dir=1;}		
if(id.dir==1) {id.device=hallRead();};	
#else	
id.device=0;	
#endif
};
*/
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					БЫСТРЫЙ ДИСКРЕТНЫЙ ВЫВОД 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	

//void RT_HW_BASE:: pinWriteQuick(RT_HW_PIN_DIR_ID &id, uint8_t pin, uint8_t v){
//if(id.dir==0) {id.dir=7; //if(id.mode==0){RT_HW_Base.directPinSetID(id,pin);if(bitRead(id.mode,RT_HW_PIN_KIND_DIR)){RT_HW_PIN_DIR_MODE_OUTPUT(id);} id.dir=1;}} 
//if(id.dir==1) {RT_HW_PIN_DIR_WRITE(id, v);}
//}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					ДИСКРЕТНЫЙ ВЫВОД 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//void  RT_HW_BASE:: pinWriteDOT(RT_HW_PIN_DOT_ID &id, int8_t pin, bool val, char open){
//if(id.dir==0) {	//if(!checkPinPGM(RT_HW_PIN_DOT_ID, pin)){id.dir=7; return;}
//				if(open=='Y') {pinMode(pin, RT_HW_PIN_MODE_OUTPUT_OPEN_DRAIN);} 
//						 else {pinMode(pin, RT_HW_PIN_MODE_OUTPUT);}		
//			    id.dir=2;} 
//if(id.dir==2) {
//	
//	digitalWrite(pin,val);}
////};

			  // RT_HW_PIN_DIR_SET_ID(id,pin);  										//--Установка параметров id; 
			  // RT_HW_PIN_DIR_MODE_OUTPUT(id);										//--Настройка пина на выход;
			  // RT_HW_PIN_DIR_WRITE(id,val);											//--Первоначальный вывод на пин;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					ШИМ ВЫВОД  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//void RT_HW_BASE:: pinWritePWM (RT_HW_PIN_PWM_ID &id, int8_t pin, uint16_t val, uint16_t freq){
/*
//-----------------------------------------------------------------------------
//if(id.dir==0) {id.freq=freq; if(id.freq==0) {id.freq=1000;} 
//               uint16_t mode=getModePin(pin); if(!bitRead(mode,RT_HW_PIN_KIND_PWM)) {id.device=0; id.dir=7; return;}
//			   }; 
//-----------------------------------------------------------------------------
#if defined(RT_HW_ARCH_AVR) || defined(RT_HW_ARCH_SAM3)
if(id.dir==0) {id.dir=1;}		//--Настройка;
if(id.dir==1) {id.device=normPWM(val); //id.device=240;  
analogWrite(pin,id.device);
}	//--Вывод ШИМ;

//-----------------------------------------------------------------------------
#elif 	defined(RT_HW_ARCH_ESP8266) 	
if(id.dir==0) {pinMode(pin,RT_HW_PIN_MODE_OUTPUT_PWM); 
         analogWriteFreq(constrain(id.freq, 100,10000)); id.dir=1;}	//--Настройка ШИМ;
if(id.dir==1) {id.device=normPWM(val); analogWrite(pin,id.device);}	//--Вывод ШИМ;		
//-----------------------------------------------------------------------------		
#elif  defined(RT_HW_ARCH_ESP32) 
if(id.dir==0){int16_t buff=getFistBitUint16(device.pwm.channel);	//--Получение номера свободного каналов PWM(переменная pwmChannelFlag);
	if(buff<0){id.device=0; id.dir=7; return;} 						//--Если все каналы заняты(num<0), выход со сбросом флага id.ok;
	id.num=buff; bitSet(device.pwm.channel,id.num);    				//--Установка флага занятости канала;
	ledcSetup(id.num,constrain(id.freq,100,40000),device.depth.pwm);//--Настройка канала id.channel: частота и разрешение;
	ledcAttachPin(pin,id.num);	id.dir=1;}		    				//--Настройка ШИМ ;
if(id.dir==1){id.device=normPWM(val); ledcWrite(id.num,id.device);}	//--Вывод ШИМ;
//-----------------------------------------------------------------------------
#elif defined(RT_HW_ARCH_STM32) 
if(id.dir==0) {pinMode(pin,RT_HW_PIN_MODE_OUTPUT_PWM); 
id.dir=1;}		//--Настройка;
if(id.dir==1) {id.device=normPWM(val);
pwmWrite(pin,id.device);
 }	//--Вывод ШИМ;	
#endif
//-----------------------------------------------------------------------------
*/
//};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					ВЫВОД DAC
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//void RT_HW_BASE:: pinWriteDAC(RT_HW_PIN_DAC_ID &id, int8_t pin, uint16_t val){
/*
//-----------------------------------------------------------------------------
#if defined(RT_HW_ARCH_SAM3) 
if(id.dir==0) {if(!bitRead(getModePin(pin),RT_HW_PIN_KIND_DAC)){id.device=0; id.dir=7; return;} id.dir=1;}; 
if(id.dir==1) {id.device=normDAC(val); analogWrite(pin,id.device);}
//-----------------------------------------------------------------------------		
#elif  defined(RT_HW_ARCH_ESP32) 
if(id.dir==0) {if(!bitRead(getModePin(pin),RT_HW_PIN_KIND_DAC)){id.device=0; id.dir=7; return;} pinMode(pin,RT_HW_PIN_MODE_INPUT); id.dir=1;}; 
if(id.dir==1) {id.device=normDAC(val); dacWrite(pin,id.device);}
//-----------------------------------------------------------------------------
#elif 	defined(RT_HW_ARCH_STM32F1) || defined(RT_HW_ARCH_STM32F4) || defined(RT_HW_ARCH_STM32H7) 
if(id.dir==0) {if(!bitRead(getModePin(pin),RT_HW_PIN_KIND_DAC)){id.device=0; id.dir=7; return;} pinMode(pin,RT_HW_PIN_MODE_INPUT); id.dir=1;}; 
if(id.dir==1) {id.device=normDAC(val);  //analogWrite(pin,id.device);
			  };	//--Вывод;	
#else
if(pin<0) {id.device=val;} id.device=0;
#endif
*/
//};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
/*
#define RT_HW_WORKING_PINS(mode,vKind,n) \
if(kind==vKind) {k=0;\
	if(mode=='S') {do{k=RT_HW_READ_BYTE_PGM(RT_HW_PIN_PGM_ALL,qnt); if(k==RT_HW_PIN_PGM_END){return cnt;} if(qnt>=127) {return cnt;} qnt++; if(k>=0) {cnt++;  }}while(1);}\
	if(mode=='A') {do{k=RT_HW_READ_BYTE_PGM(RT_HW_PIN_PGM_ALL,qnt); if(k==RT_HW_PIN_PGM_END){return cnt;} if(qnt>=127) {return cnt;} qnt++;           cnt++;   }while(1);}\
    if(mode=='P') {do{k=RT_HW_READ_BYTE_PGM(RT_HW_PIN_PGM_ALL,qnt); if(k==RT_HW_PIN_PGM_END){return  -1;} if(qnt>=127) {return  -1;} qnt++; if(k==n){return n;}}while(1);}\
	if(mode=='V') {do{k=RT_HW_READ_BYTE_PGM(RT_HW_PIN_PGM_ALL,qnt); if(k==RT_HW_PIN_PGM_END){break;}      if(qnt>=127) {break;}      qnt++;           cnt++;   }while(1);\
				   if(n>cnt) {return 0;} return RT_HW_READ_BYTE_PGM(RT_HW_PIN_PGM_ALL,n);}}
*/				   

//-------------------------------------------------------------------------------------------------
//  Получение номера пина из массива и размер массива
//  При n<0  возвращает размер массива index.
//  При n>=0 возвращает -1, если в массив index отсутствует номер пина n. 
//           Если пин с номером n имеется, то возвращается значение n.
//------------------------------------------------------------------------------------------------- 
//int8_t RT_HW_BASE:: getValPGM(uint8_t kind, int8_t n) {int8_t k; uint8_t qnt=0;
//if(kind==RT_HW_PIN_KIND_ALL) {do{k=RT_HW_READ_BYTE_PGM(RT_HW_PIN_PGM_DEBUG,qnt); 
//                              if(k==-2)  {return -1;} 
//							  if(qnt==n) {return k;} 
//							  qnt++; 
//							  if(qnt>=127) {return -1;} 
//							  }while(1);};
//};






//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					1. Служебные функции
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					1.1.Возвращает слово конфигурации пина (биты 0-7)
// mode: bit15	- пин обработан, свойства пина сформированы;
//		 bit14  - запрещено использование пина;
//  	 bit0	- свойство DIN;
//  	 bit1	- свойство ADC;
//  	 bit2	- свойство DOT;
//  	 bit3	- свойство PWM;
//  	 bit4	- свойство DAC;
//  	 bit5	- свойство TCH;
//  	 bit6	- свойство DIR;
//  	 bit7	- свойство INT;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//uint16_t RT_HW_BASE:: getModePin(int8_t pin) {int8_t x; uint16_t mode=0; if(pin<0) {return 0xC000;}; //--Пины 15,14;
//for(uint8_t i=0; i<RT_HW_PIN_KIND_QNT;i++){
// for(uint8_t j=0;j<RT_HW_PIN_QNT_MAX;j++) {x=checkPinKind(j,i); if ((j==pin) && (x>=0)) {bitSet(mode,i);}}}  
//if(mode==0) {bitSet(mode,RT_HW_PIN_KIND_BAN);}	//--Установка флага блокировки(если пин не принадлежит ни одной из групп);
//             bitSet(mode,RT_HW_PIN_INIT_MODE);	//--Установка бита "пин обработан";
//return mode;
//};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					1.2.Возвращает кол-во пинов в группе;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//uint8_t RT_HW_BASE:: calcQntKindPins(uint8_t kind){uint8_t qnt=0;
//for(uint8_t i=0; i<RT_HW_PIN_QNT_MAX; i++) {if(checkPinKind(i,kind)>=0) qnt++;} 
//return qnt;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					1.3.Проверяет принадлежность пина к группе с типом kind
//		(если не принадлежит к указанной группе, то возвращает -1, иначе возвращает номер пина)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//int8_t RT_HW_BASE:: checkPinKind(int8_t pin, uint8_t kind) {if(pin<0) {return -1;}; uint8_t p=pin;
//if(kind==RT_HW_PIN_KIND_ALL) {return RT_HW_PIN_CHECK_ALL(p);}
//if(kind==RT_HW_PIN_KIND_DIN) {return RT_HW_PIN_CHECK_DIN(p);}
//if(kind==RT_HW_PIN_KIND_ADC) {return RT_HW_PIN_CHECK_ADC(p);}
//if(kind==RT_HW_PIN_KIND_DOT) {return RT_HW_PIN_CHECK_DOT(p);}
//if(kind==RT_HW_PIN_KIND_PWM) {return RT_HW_PIN_CHECK_PWM(p);}
//if(kind==RT_HW_PIN_KIND_DAC) {return RT_HW_PIN_CHECK_DAC(p);}
//if(kind==RT_HW_PIN_KIND_TCH) {return RT_HW_PIN_CHECK_TCH(p);}
//if(kind==RT_HW_PIN_KIND_DIR) {return RT_HW_PIN_CHECK_DIR(p);}    
//if(kind==RT_HW_PIN_KIND_INT) {return RT_HW_PIN_CHECK_INT(p);}
//return -1;}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					2. Работа с пинами через прямое управление (пины со свойством DIR)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					2.1. Устанавливает параметры пина для пинов с прямым управлением
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//void RT_HW_BASE:: directPinSetID(RT_HW_PIN_DIR_ID &id,int8_t pin) {
//if(id.mode==0){id.pin=pin; id.dir=7; id.mode=getModePin(pin);  bitSet(id.mode,15);	//--Установка флага "Пин обработан" 
//if(bitRead(id.mode,RT_HW_PIN_KIND_DIR)) {RT_HW_PIN_DIR_SET_ID(id,id.pin);}}
//}; 		//--Установка параметров для пинов с прямым доступом;