#include "RT_HW_BASE.h"	 

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			1.Выводит на консоль таблицу с номерами пинов ESP8266
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void  RT_HW_BASE:: ConsoleTablePinsESP8266(){
#if defined(RT_HW_ARCH_ESP8266)
consoleText(RT_HW_BOARD_NAME_PINS_ESP8266_1,'L');
consoleText(RT_HW_BOARD_NAME_PINS_ESP8266_2,'L');
#endif
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			2.Возвращает имя пина по его номеру для плат на ESP8266
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
String 	RT_HW_BASE:: getNamePinESP8266(int8_t pin){
#if defined(RT_HW_ARCH_ESP8266)
if(pin==D0) {return String(F("D0"));}
if(pin==D1) {return String(F("D1"));}
if(pin==D2) {return String(F("D2"));}
if(pin==D3) {return String(F("D3"));}
if(pin==D4) {return String(F("D4"));}
if(pin==D5) {return String(F("D5"));}
if(pin==D6) {return String(F("D6"));}
if(pin==D7) {return String(F("D7"));}
if(pin==D8) {return String(F("D8"));}
if(pin==D9) {return String(F("D9"));}
if(pin==D10){return String(F("D10"));}
if(pin==A0) {return String(F("A0"));}
return String(F("**"));
#endif
return String(F("--"));} 


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			3.Выводит на консоль таблицу с номерами пинов STM32
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void  RT_HW_BASE:: ConsoleTablePinsSTM32(){
#if defined(RT_HW_ARCH_STM32DUINO)
for(  uint8_t i=0; i<=8;  i++) {uint8_t cnt=0;int8_t pin;
  for(uint8_t j=0; j<=15; j++){if(checkPinSTM32('A'+i,j)!=-1) {cnt++;} }
  if(cnt>0){uint8_t dl=0; uint8_t bl=0; consoleChar('A'+i,'['); ConsoleVal('D',0,']',cnt); consoleBlank(2); 
            for(uint8_t j=0; j<16; j++) {
			 if(dl) {consoleChar(','); if(pin<10){consoleBlank(1);} dl=0;}
             pin=checkPinSTM32(('A'+i),j);
             if(pin==-1) {bl=7; if((j>10)&&(j<15)) {bl++;}  consoleBlank(bl,'+'); dl=0;}
                    else {bl=0; consoleChar('P');  consoleChar('A'+i);
								ConsoleVal('S',0,'=',j); ConsoleVal('S',0,'~',pin); dl=1;}   
            } consoleSuff('E');  }}
return;			
#endif
//-------------------------------------------------------------------------------------------------
// 		Для платы STM32MASTER->RT_HW_BOARD_GENERIC_STM32F103C :enum->
//PA0, PA1, PA2, PA3, PA4, PA5, PA6, PA7, PA8, PA9, PA10, PA11, PA12, PA13,PA14,PA15,
//PB0, PB1, PB2, PB3, PB4, PB5, PB6, PB7, PB8, PB9, PB10, PB11, PB12, PB13,PB14,PB15,
//PC13,PC14,PC15,
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_BRD_STM32F103C)
for(uint8_t i=0; i<16;i++) {consoleText(String(F("PA"))); consoleInt8(i);    consoleChar('='); consoleInt8(i);    if(i<15){consoleSuff(','); if(i<10) {consoleSuff('G');}} else {consoleSuff('E');}}
for(uint8_t i=0; i<16;i++) {consoleText(String(F("PB"))); consoleInt8(i);    consoleChar('='); consoleInt8(i+16); if(i<15){consoleSuff(',');}                              else {consoleSuff('E');}} 
consoleBlank(94);
for(uint8_t i=0; i<3; i++) {consoleText(String(F("PC"))); consoleInt8(i+13); consoleChar('='); consoleInt8(i+32); if(i<2) {consoleSuff(',');}                              else {consoleSuff('E');}}
return;
#endif
//-------------------------------------------------------------------------------------------------
// 		Для платы STM32MASTER->RT_HW_BOARD_GENERIC_STM32F103R  :enum->
//PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12,PA13,PA14,PA15,
//PB0,PB1,PB2,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10,PB11,PB12,PB13,PB14,PB15,
//PC0,PC1,PC2,PC3,PC4,PC5,PC6,PC7,PC8,PC9,PC10,PC11,PC12,PC13,PC14,PC15,
//PD2
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_BRD_STM32F103R)
for(uint8_t i=0; i<16;i++) {consoleText(String(F("PA"))); consoleInt8(i);    consoleChar('='); consoleInt8(i);   if(i<15){consoleSuff(','); if(i<10) {consoleSuff('G');}} else {consoleSuff('E');}}
for(uint8_t i=0; i<16;i++) {consoleText(String(F("PB"))); consoleInt8(i);    consoleChar('='); consoleInt8(i+16);if(i<15){consoleSuff(',');}                              else {consoleSuff('E');}}
for(uint8_t i=0; i<16;i++) {consoleText(String(F("PC"))); consoleInt8(i);    consoleChar('='); consoleInt8(i+32);if(i<15){consoleSuff(',');}                              else {consoleSuff('E');}}
printBlank(14);             consoleText(String(F("PD2=")));consoleInt8(PD2); consoleChar(';','Y');
return;
#endif
//-------------------------------------------------------------------------------------------------
// 		Для платы STM32MASTER->RT_HW_BOARD_GENERIC_STM32F103V  :enum->
//PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12,PA13,PA14,PA15,
//PB0,PB1,PB2,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10,PB11,PB12,PB13,PB14,PB15,
//PC0,PC1,PC2,PC3,PC4,PC5,PC6,PC7,PC8,PC9,PC10,PC11,PC12,PC13,PC14,PC15,
//PD0,PD1,PD2,PD3,PD4,PD5,PD6,PD7,PD8,PD9,PD10,PD11,PD12,PD13,PD14,PD15,
//PE0,PE1,PE2,PE3,PE4,PE5,PE6,PE7,PE8,PE9,PE10,PE11,PE12,PE13,PE14,PE15,
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_BRD_STM32F103V) || defined(RT_HW_BRD_STM32F407V)
for(uint8_t i=0; i<16;i++) {consoleText(String(F("PA"))); consoleInt8(i);    consoleChar('='); consoleInt8(i);    if(i<15){consoleSuff(','); if(i<10) {consoleSuff('G');}} else {consoleSuff('E');}}
for(uint8_t i=0; i<16;i++) {consoleText(String(F("PB"))); consoleInt8(i);    consoleChar('='); consoleInt8(i+16); if(i<15){consoleSuff(',');} 							   else {consoleSuff('E');}}
for(uint8_t i=0; i<16;i++) {consoleText(String(F("PC"))); consoleInt8(i);    consoleChar('='); consoleInt8(i+32); if(i<15){consoleSuff(',');} 							   else {consoleSuff('E');}}
for(uint8_t i=0; i<16;i++) {consoleText(String(F("PD"))); consoleInt8(i);    consoleChar('='); consoleInt8(i+48); if(i<15){consoleSuff(',');} 							   else {consoleSuff('E');}}
for(uint8_t i=0; i<16;i++) {consoleText(String(F("PE"))); consoleInt8(i);    consoleChar('='); consoleInt8(i+64); if(i<15){consoleSuff(',');} 							   else {consoleSuff('E');}}
return;
#endif
//-------------------------------------------------------------------------------------------------
};	//--END void  RT_HW_BASE:: printTablePinsSTM32(){
	

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		4.Возвращает имя пина по его номеру для плат на STM32
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
String 	RT_HW_BASE:: getNamePinSTM32(int8_t pin){
//-------------------------------------------------------------------------------------------------
// Для всех плат STM32DUINO
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_ARCH_STM32DUINO)   //--Пины определены через #define
if(pin<0) {return String(F("   "));}	
for(uint8_t i=0; i<=8; i++){for(uint8_t j=0; j<16; j++){
	if(checkPinSTM32('A'+i, j)==pin) return (String('P')+String(char((uint8_t)'A'+i))+String(j));}}
	return (String(F("***pin="))+String(pin));	
#endif

//-------------------------------------------------------------------------------------------------
// Для всех плат STM32-master
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_ARCH_STM32MASTER)
//-------------------------------------------------------------------------------------------------
// Для платы STM32MASTER->RT_HW_BOARD_GENERIC_STM32F103C
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_BRD_STM32F103C) || defined(RT_HW_BRD_BLACKPILL_F401C) || defined(RT_HW_BRD_BLACKPILL_F411C) 
if(pin<0)   {return  String("***");} 
if(pin<16)  {return (String("PA")+String(pin));} 
if(pin<32)  {return (String("PB")+String(pin-16));} 
if(pin<35)  {return (String("PC")+String(pin-32+13));} 
return (String("Px")+String(pin));
#endif
//-------------------------------------------------------------------------------------------------
// Для платы STM32MASTER->RT_HW_BOARD_GENERIC_STM32F103R
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_BRD_STM32F103R)
if(pin<0)   {return  String("***");} 
if(pin<16)  {return (String("PA")+String(pin));} 
if(pin<32)  {return (String("PB")+String(pin-16));} 
if(pin<48)  {return (String("PC")+String(pin-32));} 
if(pin==PD2){return (String("PD")+String(PD2));} 
return (String("Px")+String(pin));
#endif
//-------------------------------------------------------------------------------------------------
// Для платы STM32MASTER->RT_HW_BOARD_GENERIC_STM32F103V
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_BRD_STM32F103V) || defined(RT_HW_BRD_STM32F407V) 
if(pin<0)   {return  String("***");} 
if(pin<16)  {return (String("PA")+String(pin));} 
if(pin<32)  {return (String("PB")+String(pin-16));} 
if(pin<48)  {return (String("PC")+String(pin-32));} 
if(pin<64)  {return (String("PD")+String(pin-48));} 
if(pin<80)  {return (String("PE")+String(pin-64));} 
return (String("Px")+String(pin));
#endif
//-------------------------------------------------------------------------------------------------
#endif
//-------------------------------------------------------------------------------------------------
// Для не установленной платы 
//-------------------------------------------------------------------------------------------------
return (String(F("P?="))+String(pin));	
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			5. Получение числового знаяения номера пина
//	Для STM32DUINO возвращает номер пина по регистру(reg) и номеру биту в регистре (num)
//		reg - обозначение регистров A,B,C,D,E,F,G(PA,PB,PC,PD,PE,PF,PG) в STM32F; 
//   	num - номер бита в регистрах (0-15);
//  Если пин отсутствует, возвращает -1;
//	Для других плат возвращает -1;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++		
int8_t RT_HW_BASE:: checkPinSTM32(char reg, uint8_t num){                                         
#if defined(RT_HW_ARCH_STM32DUINO)
//===============================================
if(reg=='A'){
//-----------------------------------------------
if(num==0){
#if defined(PA0)
return PA0;
#endif
}//----------------------------------------------
if(num==1){
#if defined(PA1)
return PA1;
#endif
}//----------------------------------------------
if(num==2){
#if defined(PA2)
return PA2; 
#endif
}//----------------------------------------------
if(num==3){
#if defined(PA3)
return PA3; 
#endif
}//-----------------------------------------------
if(num==4){
#if defined(PA4)
return PA4; 
#endif
}//-----------------------------------------------
if(num==5){
#if defined(PA5)
return PA5; 
#endif
}//-----------------------------------------------
if(num==6){
#if defined(PA6)
return PA6; 
#endif
}//-----------------------------------------------
if(num==7){
#if defined(PA7)
return PA7; 
#endif
}//----------------------------------------------
if(num==8){
#if defined(PA8)
return PA8;
#endif
}//----------------------------------------------
if(num==9){
#if defined(PA9)
return PA9;
#endif
}//----------------------------------------------
if(num==10){
#if defined(PA10)
return PA10; 
#endif
}//----------------------------------------------
if(num==11){
#if defined(PA11)
return PA11; 
#endif
}//-----------------------------------------------
if(num==12){
#if defined(PA12)
return PA12; 
#endif
}//-----------------------------------------------
if(num==13){
#if defined(PA13)
return PA13; 
#endif
}//-----------------------------------------------
if(num==14){
#if defined(PA14)
return PA14; 
#endif
}//-----------------------------------------------
if(num==15){
#if defined(PA15)
return PA15; 
#endif
}} // END PA ---и т.д. 0-15;
//===============================================
if(reg=='B'){
//-----------------------------------------------
if(num==0){
#if defined(PB0)
return PB0;
#endif
}//----------------------------------------------
if(num==1){
#if defined(PB1)
return PB1;
#endif
}//----------------------------------------------
if(num==2){
#if defined(PB2)
return PB2; 
#endif
}//----------------------------------------------
if(num==3){
#if defined(PB3)
return PB3; 
#endif
}//-----------------------------------------------
if(num==4){
#if defined(PB4)
return PB4; 
#endif
}//-----------------------------------------------
if(num==5){
#if defined(PB5)
return PB5; 
#endif
}//-----------------------------------------------
if(num==6){
#if defined(PB6)
return PB6; 
#endif
}//-----------------------------------------------
if(num==7){
#if defined(PB7)
return PB7; 
#endif
}//----------------------------------------------
if(num==8){
#if defined(PB8)
return PB8;
#endif
}//----------------------------------------------
if(num==9){
#if defined(PB9)
return PB9;
#endif
}//----------------------------------------------
if(num==10){
#if defined(PB10)
return PB10; 
#endif
}//----------------------------------------------
if(num==11){
#if defined(PB11)
return PB11; 
#endif
}//-----------------------------------------------
if(num==12){
#if defined(PB12)
return PB12; 
#endif
}//-----------------------------------------------
if(num==13){
#if defined(PB13)
return PB13; 
#endif
}//-----------------------------------------------
if(num==14){
#if defined(PB14)
return PB14; 
#endif
}//-----------------------------------------------
if(num==15){
#if defined(PB15)
return PB15; 
#endif
}}	// END PB ---и т.д. 0-15;

//===============================================
if(reg=='C'){
//-----------------------------------------------
if(num==0){
#if defined(PC0)
return PC0;
#endif
}//----------------------------------------------
if(num==1){
#if defined(PC1)
return PC1;
#endif
}//----------------------------------------------
if(num==2){
#if defined(PC2)
return PC2; 
#endif
}//----------------------------------------------
if(num==3){
#if defined(PC3)
return PC3; 
#endif
}//-----------------------------------------------
if(num==4){
#if defined(PC4)
return PC4; 
#endif
}//-----------------------------------------------
if(num==5){
#if defined(PC5)
return PC5; 
#endif
}//-----------------------------------------------
if(num==6){
#if defined(PC6)
return PC6; 
#endif
}//-----------------------------------------------
if(num==7){
#if defined(PC7)
return PC7; 
#endif
}//----------------------------------------------
if(num==8){
#if defined(PC8)
return PC8;
#endif
}//----------------------------------------------
if(num==9){
#if defined(PC9)
return PC9;
#endif
}//----------------------------------------------
if(num==10){
#if defined(PC10)
return PC10; 
#endif
}//----------------------------------------------
if(num==11){
#if defined(PC11)
return PC11; 
#endif
}//-----------------------------------------------
if(num==12){
#if defined(PC12)
return PC12; 
#endif
}//-----------------------------------------------
if(num==13){
#if defined(PC13)
return PC13; 
#endif
}//-----------------------------------------------
if(num==14){
#if defined(PC14)
return PC14; 
#endif
}//-----------------------------------------------
if(num==15){
#if defined(PC15)
return PC15; 
#endif
}}// END PC ---и т.д. 0-15;
//===============================================
if(reg=='D'){
//-----------------------------------------------
if(num==0){
#if defined(PD0)
return PD0;
#endif
}//----------------------------------------------
if(num==1){
#if defined(PD1)
return PD1;
#endif
}//----------------------------------------------
if(num==2){
#if defined(PD2)
return PD2; 
#endif
}//----------------------------------------------
if(num==3){
#if defined(PD3)
return PD3; 
#endif
}//-----------------------------------------------
if(num==4){
#if defined(PD4)
return PD4; 
#endif
}//-----------------------------------------------
if(num==5){
#if defined(PD5)
return PD5; 
#endif
}//-----------------------------------------------
if(num==6){
#if defined(PD6)
return PD6; 
#endif
}//-----------------------------------------------
if(num==7){
#if defined(PD7)
return PD7; 
#endif
}//----------------------------------------------
if(num==8){
#if defined(PD8)
return PD8;
#endif
}//----------------------------------------------
if(num==9){
#if defined(PD9)
return PD9;
#endif
}//----------------------------------------------
if(num==10){
#if defined(PD10)
return PD10; 
#endif
}//----------------------------------------------
if(num==11){
#if defined(PD11)
return PD11; 
#endif
}//-----------------------------------------------
if(num==12){
#if defined(PD12)
return PD12; 
#endif
}//-----------------------------------------------
if(num==13){
#if defined(PD13)
return PD13; 
#endif
}//-----------------------------------------------
if(num==14){
#if defined(PD14)
return PD14; 
#endif
}//-----------------------------------------------
if(num==15){
#if defined(PD15)
return PD15; 
#endif
}}// END PD ---и т.д. 0-15;

//===============================================
if(reg=='E'){
//-----------------------------------------------
if(num==0){
#if defined(PE0)
return PE0;
#endif
}//----------------------------------------------
if(num==1){
#if defined(PE1)
return PE1;
#endif
}//----------------------------------------------
if(num==2){
#if defined(PE2)
return PE2; 
#endif
}//----------------------------------------------
if(num==3){
#if defined(PE3)
return PE3; 
#endif
}//-----------------------------------------------
if(num==4){
#if defined(PE4)
return PE4; 
#endif
}//-----------------------------------------------
if(num==5){
#if defined(PE5)
return PE5; 
#endif
}//-----------------------------------------------
if(num==6){
#if defined(PE6)
return PE6; 
#endif
}//-----------------------------------------------
if(num==7){
#if defined(PE7)
return PE7; 
#endif
}//----------------------------------------------
if(num==8){
#if defined(PE8)
return PE8;
#endif
}//----------------------------------------------
if(num==9){
#if defined(PE9)
return PE9;
#endif
}//----------------------------------------------
if(num==10){
#if defined(PE10)
return PE10; 
#endif
}//----------------------------------------------
if(num==11){
#if defined(PE11)
return PE11; 
#endif
}//-----------------------------------------------
if(num==12){
#if defined(PE12)
return PE12; 
#endif
}//-----------------------------------------------
if(num==13){
#if defined(PE13)
return PE13; 
#endif
}//-----------------------------------------------
if(num==14){
#if defined(PE14)
return PE14; 
#endif
}//-----------------------------------------------
if(num==15){
#if defined(PE15)
return PE15; 
#endif
}}	//--END PE ---и т.д. 0-15;
//===============================================
if(reg=='F'){
//-----------------------------------------------
if(num==0){
#if defined(PF0)
return PF0;
#endif
}//----------------------------------------------
if(num==1){
#if defined(PF1)
return PF1;
#endif
}//----------------------------------------------
if(num==2){
#if defined(PF2)
return PF2; 
#endif
}//----------------------------------------------
if(num==3){
#if defined(PF3)
return PF3; 
#endif
}//-----------------------------------------------
if(num==4){
#if defined(PF4)
return PF4; 
#endif
}//-----------------------------------------------
if(num==5){
#if defined(PF5)
return PF5; 
#endif
}//-----------------------------------------------
if(num==6){
#if defined(PF6)
return PF6; 
#endif
}//-----------------------------------------------
if(num==7){
#if defined(PF7)
return PF7; 
#endif
}//----------------------------------------------
if(num==8){
#if defined(PF8)
return PF8;
#endif
}//----------------------------------------------
if(num==9){
#if defined(PF9)
return PF9;
#endif
}//----------------------------------------------
if(num==10){
#if defined(PF10)
return PF10; 
#endif
}//----------------------------------------------
if(num==11){
#if defined(PF11)
return PF11; 
#endif
}//-----------------------------------------------
if(num==12){
#if defined(PF12)
return PF12; 
#endif
}//-----------------------------------------------
if(num==13){
#if defined(PF13)
return PF13; 
#endif
}//-----------------------------------------------
if(num==14){
#if defined(PF14)
return PF14; 
#endif
}//-----------------------------------------------
if(num==15){
#if defined(PF15)
return PF15; 
#endif
}}	//--END PF ---и т.д. 0-15;

//===============================================
if(reg=='G'){
//-----------------------------------------------
if(num==0){
#if defined(PG0)
return PG0;
#endif
}//----------------------------------------------
if(num==1){
#if defined(PG1)
return PG1;
#endif
}//----------------------------------------------
if(num==2){
#if defined(PG2)
return PG2; 
#endif
}//----------------------------------------------
if(num==3){
#if defined(PG3)
return PG3; 
#endif
}//-----------------------------------------------
if(num==4){
#if defined(PG4)
return PG4; 
#endif
}//-----------------------------------------------
if(num==5){
#if defined(PG5)
return PG5; 
#endif
}//-----------------------------------------------
if(num==6){
#if defined(PG6)
return PG6; 
#endif
}//-----------------------------------------------
if(num==7){
#if defined(PG7)
return PG7; 
#endif
}//----------------------------------------------
if(num==8){
#if defined(PG8)
return PG8;
#endif
}//----------------------------------------------
if(num==9){
#if defined(PG9)
return PG9;
#endif
}//----------------------------------------------
if(num==10){
#if defined(PG10)
return PG10; 
#endif
}//----------------------------------------------
if(num==11){
#if defined(PG11)
return PG11; 
#endif
}//-----------------------------------------------
if(num==12){
#if defined(PG12)
return PG12; 
#endif
}//-----------------------------------------------
if(num==13){
#if defined(PG13)
return PG13; 
#endif
}//-----------------------------------------------
if(num==14){
#if defined(PG14)
return PG14; 
#endif
}//-----------------------------------------------
if(num==15){
#if defined(PG15)
return PG15; 
#endif
}}	//--END PG ---и т.д. 0-15;
#endif   		//--END #if defined(RT_HW_ARCH_STM32DUINO) 
//================================================
if((reg>'G') || (num>15)) {return -1;}	//--Защита от предупреждений компилятора;
return -1;};	//--END getNumPin(char reg, uint8_t num)
//==============================================================================


/*

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		Возвращает таблицу с номерами пинов для STM32
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void  RT_HW_BASE:: printTablePinsSTM32(){
#if defined(RT_HW_ARCH_STM32DUINO)
for(  uint8_t i=0; i<=8;  i++) {uint8_t cnt=0;int8_t pin;
  for(uint8_t j=0; j<=15; j++){if(checkPinSTM32('A'+i,j)!=-1) {cnt++;} }
  if(cnt>0){uint8_t dl=0; uint8_t bl=0; printChar('A'+i,'['); printVal('D',0,']',cnt); printBlank(2); 
            for(uint8_t j=0; j<16; j++) {if(dl) {printChar(','); if(pin<10){printBlank(1);} dl=0;}
             pin=checkPinSTM32(('A'+i),j);
             if(pin==-1) {bl=7; if((j>10)&&(j<15)) {bl++;}  RT_HW_Base.printBlank(bl); dl=0;}
                    else {bl=0; RT_HW_Base.printChar('P');  RT_HW_Base.printChar('A'+i);
                          RT_HW_Base.printVal('S',0,'=',j); RT_HW_Base.printVal('S',0,'~',pin); dl=1;}   
            } RT_HW_Base.printChar(';','Y');  }}
#endif
//-------------------------------------------------------------------------------------------------
// 		Для платы STM32MASTER->RT_HW_BOARD_GENERIC_STM32F103C :enum->
//PA0, PA1, PA2, PA3, PA4, PA5, PA6, PA7, PA8, PA9, PA10, PA11, PA12, PA13,PA14,PA15,
//PB0, PB1, PB2, PB3, PB4, PB5, PB6, PB7, PB8, PB9, PB10, PB11, PB12, PB13,PB14,PB15,
//PC13,PC14,PC15,
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_BOARD_GENERIC_STM32F103C)
for(uint8_t i=0; i<16;i++) {printTxt(String(F("PA"))); printInt8(i);    printChar('='); printInt8(i);    if(i<15) {printChar(','); if(i<10) {printBlank(1);}} else {printChar(';','Y');} }
for(uint8_t i=0; i<16;i++) {printTxt(String(F("PB"))); printInt8(i);    printChar('='); printInt8(i+16); if(i<15){printChar(',');} else {printChar(';','Y');}}
printBlank(94);
for(uint8_t i=0; i<3; i++) {printTxt(String(F("PC"))); printInt8(i+13); printChar('='); printInt8(i+32); if(i<2) {printChar(',');} else {printChar(';','Y');}}
#endif
//-------------------------------------------------------------------------------------------------
// 		Для платы STM32MASTER->RT_HW_BOARD_GENERIC_STM32F103R  :enum->
//PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12,PA13,PA14,PA15,
//PB0,PB1,PB2,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10,PB11,PB12,PB13,PB14,PB15,
//PC0,PC1,PC2,PC3,PC4,PC5,PC6,PC7,PC8,PC9,PC10,PC11,PC12,PC13,PC14,PC15,
//PD2
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_BOARD_GENERIC_STM32F103R)
for(uint8_t i=0; i<16;i++) {printTxt(String(F("PA"))); printInt8(i);    printChar('='); printInt8(i);    if(i<15) {printChar(','); if(i<10) {printBlank(1);}} else {printChar(';','Y');} }
for(uint8_t i=0; i<16;i++) {printTxt(String(F("PB"))); printInt8(i);    printChar('='); printInt8(i+16); if(i<15){printChar(',');} else {printChar(';','Y');}}
for(uint8_t i=0; i<16;i++) {printTxt(String(F("PC"))); printInt8(i);    printChar('='); printInt8(i+32); if(i<15){printChar(',');} else {printChar(';','Y');}}
printBlank(14);             printTxt(String(F("PD2=")));printInt8(PD2); printChar(';','Y');
#endif
//-------------------------------------------------------------------------------------------------
// 		Для платы STM32MASTER->RT_HW_BOARD_GENERIC_STM32F103V  :enum->
//PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12,PA13,PA14,PA15,
//PB0,PB1,PB2,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10,PB11,PB12,PB13,PB14,PB15,
//PC0,PC1,PC2,PC3,PC4,PC5,PC6,PC7,PC8,PC9,PC10,PC11,PC12,PC13,PC14,PC15,
//PD0,PD1,PD2,PD3,PD4,PD5,PD6,PD7,PD8,PD9,PD10,PD11,PD12,PD13,PD14,PD15,
//PE0,PE1,PE2,PE3,PE4,PE5,PE6,PE7,PE8,PE9,PE10,PE11,PE12,PE13,PE14,PE15,
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_BOARD_GENERIC_STM32F103V)
for(uint8_t i=0; i<16;i++) {printTxt(String(F("PA"))); printInt8(i);    printChar('='); printInt8(i);    if(i<15) {printChar(','); if(i<10) {printBlank(1);}} else {printChar(';','Y');} }
for(uint8_t i=0; i<16;i++) {printTxt(String(F("PB"))); printInt8(i);    printChar('='); printInt8(i+16); if(i<15){printChar(',');} else {printChar(';','Y');}}
for(uint8_t i=0; i<16;i++) {printTxt(String(F("PC"))); printInt8(i);    printChar('='); printInt8(i+32); if(i<15){printChar(',');} else {printChar(';','Y');}}
for(uint8_t i=0; i<16;i++) {printTxt(String(F("PD"))); printInt8(i);    printChar('='); printInt8(i+48); if(i<15){printChar(',');} else {printChar(';','Y');}}
for(uint8_t i=0; i<16;i++) {printTxt(String(F("PE"))); printInt8(i);    printChar('='); printInt8(i+64); if(i<15){printChar(',');} else {printChar(';','Y');}}
#endif
//-------------------------------------------------------------------------------------------------
};	//--END void  RT_HW_BASE:: printTablePinsSTM32(){
*/
