 #include "RT_HW_BASE.h"
//--Использовано https://soltau.ru/index.php/arduino/item/371-interfejs-i2c-i-arduino
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 				1. Определение дополнительных шин i2c
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_PERMIT_I2C1) && defined(RT_HW_ARCH_STM32)
  TwoWire Wire1(RT_HW_I2C1_SDA,  RT_HW_I2C1_SCL);
#endif
#if defined(RT_HW_PERMIT_I2C2) && defined(RT_HW_ARCH_STM32)
  TwoWire Wire2(RT_HW_I2C2_SDA, RT_HW_I2C2_SСL);
#endif
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 				2. Конвертация кода скорости в значение скорости  i2c
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint32_t RT_HW_BASE:: convertModeFreqWire(uint8_t mode){
if(mode==RT_HW_I2C_MODE_LOW)	{return RT_HW_I2C_SPEED_LOW;}
if(mode==RT_HW_I2C_MODE_ST)		{return RT_HW_I2C_SPEED_ST;} 
if(mode==RT_HW_I2C_MODE_FM)		{return RT_HW_I2C_SPEED_FM;}
if(mode==RT_HW_I2C_MODE_FM1) 	{return RT_HW_I2C_SPEED_FM1;}
if(mode==RT_HW_I2C_MODE_FM2) 	{return RT_HW_I2C_SPEED_FM2;}
if(mode==RT_HW_I2C_MODE_FMP) 	{return RT_HW_I2C_SPEED_FMP;}
if(mode==RT_HW_I2C_MODE_HS) 	{return RT_HW_I2C_SPEED_HS;}
if(mode==RT_HW_I2C_MODE_UFM) 	{return RT_HW_I2C_SPEED_UFM;};
return RT_HW_I2C_SPEED_ST;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1. Инициализация библиотеки и подключение к шине I2C; 
// Если адрес<0, то присоединённое устройство считается ведущим, 
//  иначе устройство настраивается как slave с адресом=adr;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: wireBegin(int8_t sda, int8_t scl, uint8_t slaveAdr, uint8_t bus){
//-------------------------------------------------------------------------------------------------
//					Архитектуры AVR,SAM3,ESP8266,ESP32
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_ARCH_AVR) || defined(RT_HW_ARCH_SAM3) || defined(RT_HW_ARCH_ESP8266) || defined(RT_HW_ARCH_ESP32)
//===========Шина i2c0=============
#if defined(RT_HW_PERMIT_I2C0)														//---шина i2c;
if(bus==0){	if(bitRead(device.i2c0.state,RT_HW_I2C_STATE_INIT)) {return;};			//--Выход, если шина инициализирована;
   if((sda>=0) && (scl>=0) && (sda!=scl)){device.i2c0.sda=sda;device.i2c0.scl=scl;} //--Измененение пинов sda,scl (здесь не важно);
   if(slaveAdr>=8) {device.i2c0.adr=slaveAdr;} 										//--Установка адреса для режима slave;
//-----------Настройка i2c как slave-------------------------------------------
   if(device.i2c0.adr>=8){bitSet(device.i2c0.state, RT_HW_I2C_STATE_SLAVE);			//--Выбор режима настройки шины master;
#if defined(RT_HW_ARCH_AVR) || defined(RT_HW_ARCH_SAM3)
		Wire.begin(device.i2c0.adr);												//--Инициализация как slave для AVR;
#endif	
#if defined(RT_HW_ARCH_ESP8266)
		Wire.begin(device.i2c0.sda,	device.i2c0.scl, device.i2c0.adr);				//--Инициализация как slave для ESP8266;
#endif
#if defined(RT_HW_ARCH_ESP32)														//--Режим slave для ESP32 не поддерживается;
#endif
			}	//--END настройки как slave
//-----------Настройка i2c как master------------------------------------------
	else                  {bitClear(device.i2c0.state ,RT_HW_I2C_STATE_SLAVE); 
#if defined(RT_HW_ARCH_AVR) || defined(RT_HW_ARCH_SAM3)
	Wire.begin();																	//--Инициализация как master для AVR;
	Wire.setClock(convertModeFreqWire (device.i2c0.speed));							//--Установка частоты шины i2c;
#endif	
#if defined(RT_HW_ARCH_ESP8266)
	Wire.begin(device.i2c0.sda,	device.i2c0.scl); 									//--Инициализация как master для ESP8266; 
	Wire.setClock(convertModeFreqWire (device.i2c0.speed));							//--Установка частоты шины i2c; 	
	Wire.setClockStretchLimit(260);													//--Ограничение лимита по времени;
#endif
#if defined(RT_HW_ARCH_ESP32) 											
	Wire.begin(device.i2c0.sda,	device.i2c0.scl);									//--Инициализация как master для ESP32;
	Wire.setClock(convertModeFreqWire (device.i2c0.speed));							//--Установка частоты шины i2c; 	
	Wire.setTimeOut(50); 															//--По умолчанию  тайм-аут на транзакцию =50ms;
#endif
//-----------------------------------------------------------------------------
			}	//--END настройки как master
//-----------------------------------------------------------------------------
bitSet(device.i2c0.state,RT_HW_I2C_STATE_INIT);	return;   }							//--Установка флага INIT ивыход; 
#endif		//--END настройки шины i2c0 для AVR,DUE,ESP8266,ESP32	
#endif		//--END настройки шин  i2c  для AVR,DUE,ESP8266,ESP32		

//-------------------------------------------------------------------------------------------------
//					Архитектуры STM32
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_ARCH_STM32)
//==================================Шина i2c0======================================================
#if defined(RT_HW_PERMIT_I2C0)		
if(bus==0){               if(bitRead(device.i2c0.state,RT_HW_I2C_STATE_INIT)) {return;};	    //--Выход, если шина инициализирована;
if((sda==scl)||(sda==-1)||(sda==-1)){device.i2c0.sda=RT_HW_I2C0_SDA; 							//--Установка 
                                     device.i2c0.scl=RT_HW_I2C0_SCL;} 							//			 конфигурационных пинов;
else                                {device.i2c0.sda=sda;    									//--Установка         
                                     device.i2c0.scl=scl;}										//           новых пинов; 
//-----Дополнительная установка номером пинов для ядра STMduino------------------------------------
#if defined(RT_HW_ARCH_STM32DUINO)						
						 Wire.setSDA(device.i2c0.sda);											//--Апппаратная настройка пина SDA;
						 Wire.setSCL(device.i2c0.scl);											//--Апппаратная настройка пина SCL;
#endif	
//-------------------------------------------------------------------------------------------------					
#if defined(RT_HW_ARCH_PERMIT_WireSlave)
					 if(slaveAdr>=8){device.i2c0.adr=slaveAdr;} 								//--Установка адреса для режима slave;
					  			  if(device.i2c0.adr>=8)										//--Выбор режима настройки шины (slave/master);
						     {bitSet(device.i2c0.state, RT_HW_I2C_STATE_SLAVE);					//--Инициализация как slave
						  Wire.begin(device.i2c0.adr);} 										//				c адресом slaveAdr;
					 else  {bitClear(device.i2c0.state ,RT_HW_I2C_STATE_SLAVE); 				//--Инициализация 
					      Wire.begin();} 														//				как master;
   Wire.setClock(convertModeFreqWire(device.i2c0.speed));										//--Установка частоты шины i2c;  
                              bitSet(device.i2c0.state,RT_HW_I2C_STATE_INIT);					//--Установка флага INIT;	
#endif
//------------------------------------------------------------------------------------------------
return;   };																					//--Выход;		
#endif
//====================================Шина i2c1====================================================
#if defined(RT_HW_PERMIT_I2C1) && defined(RT_HW_ARCH_STM32DUINO)								//--Шина i2c1 только в среде ;
if(bus==1){      		 if(bitRead (device.i2c1.state,RT_HW_I2C_STATE_INIT)) {return;};		//--Выход, если шина инициализирована;
if((sda==scl)||(sda==-1)||(sda==-1)){device.i2c1.sda=RT_HW_I2C1_SDA; 							//--Установка 
                                     device.i2c1.scl=RT_HW_I2C1_SCL;}							//          конфигурационных пинов;
else                                {device.i2c1.sda=sda;            							//--Установка 
                                     device.i2c1.scl=scl;}										//          новых пинов; 
//-----Дополнительная установка номером пинов для ядра STMduino------------------------------------					
						 Wire1.setSDA(device.i2c1.sda);											//--Апппаратная настройка пина SDA;
						 Wire1.setSCL(device.i2c1.scl);											//--Апппаратная настройка пина SCL;
//-------------------------------------------------------------------------------------------------					
#if defined(RT_HW_ARCH_PERMIT_WireSlave)
					 if(slaveAdr>=8){device.i2c1.adr=slaveAdr;} 									//--Установка адреса для режима slave;
								  if(device.i2c1.adr>=8)											//--Выбор режима настройки шины (slave/master);
						     {bitSet(device.i2c1.state, RT_HW_I2C_STATE_SLAVE);					//--Инициализация как slave
					     Wire1.begin(device.i2c1.adr);} 										//				c адресом slaveAdr;
					 else  {bitClear(device.i2c1.state ,RT_HW_I2C_STATE_SLAVE); 				//--Инициализация как master;
					     Wire1.begin();} 														//--Инициализация как master;
  Wire1.setClock(convertModeFreqWire(device.i2c1.speed));										//--Установка частоты шины i2c;  
                              bitSet(device.i2c1.state,RT_HW_I2C_STATE_INIT);					//--Установка флага INIT;
#endif
//------------------------------------------------------------------------------------------------
return;   }																						//--Выход; 
#endif
//=====================================Шина i2c2===================================================
#if defined(RT_HW_PERMIT_I2C2)	&& defined(RT_HW_ARCH_STM32DUINO)								//--Шина i2c2;
if(bus==2){        		  if(bitRead(device.i2c2.state,RT_HW_I2C_STATE_INIT)) {return;};		//--Выход, если шина инициализирована;
if((sda==scl)||(sda==-1)||(sda==-1)){device.i2c2.sda=RT_HW_I2C2_SDA; 							//--Установка 
									 device.i2c2.scl=RT_HW_I2C2_SCL;} 							//           конфигурационных пинов;
else                                {device.i2c2.sda=sda;            							//--Установка 
									 device.i2c2.scl=scl;}			  							//          новых пинов; 
//-----Дополнительная установка номером пинов для ядра STMduino------------------------------------					
						Wire2.setSDA(device.i2c2.sda);											//--Апппаратная настройка пина SDA;
						Wire2.setSCL(device.i2c2.scl);											//--Апппаратная настройка пина SCL;
//-------------------------------------------------------------------------------------------------										
#if defined(RT_HW_ARCH_PERMIT_WireSlave)
					 if(slaveAdr>=8){device.i2c2.adr=slaveAdr;} 								//--Установка адреса для режима slave;
								  if(device.i2c2.adr>=8)										//--Выбор режима настройки шины (slave/master);
						     {bitSet(device.i2c2.state, RT_HW_I2C_STATE_SLAVE);					//--Инициализация как slave
						 Wire2.begin(device.i2c2.adr);} 											//				c адресом slaveAdr;
					 else  {bitClear(device.i2c2.state ,RT_HW_I2C_STATE_SLAVE); 
					     Wire2.begin();} 	//--Инициализация как master;
 Wire2.setClock(convertModeFreqWire(device.i2c2.speed));										//--Установка частоты шины i2c;  
                             bitSet(device.i2c2.state,RT_HW_I2C_STATE_INIT);					//--Установка флага INIT;
#endif
//------------------------------------------------------------------------------------------------
return;   }																						//--Выход; 
#endif
#endif		
};	//--END wireBegin(int8_t sda,int8_t scl, int8_t bus)
 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						2. Установка частоты i2c 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: wireSetClock(uint8_t speed, uint8_t bus){
//-----Архитектуры AVR,DUE-------------------------------------------------------------------------
#if defined(RT_HW_ARCH_AVR) || defined(RT_HW_ARCH_ESP)      || \
    defined(RT_HW_ARCH_SAM3)|| defined(RT_HW_ARCH_SEEDUINO) || defined(RT_HW_ARCH_STM32)
#if defined(RT_HW_PERMIT_I2C0)
if(bus==0){device.i2c0.speed=speed; Wire.setClock(convertModeFreqWire(device.i2c0.speed)); return;};
#endif	
#if defined(RT_HW_PERMIT_I2C1)
if(bus==1){device.i2c1.speed=speed; Wire1.setClock(convertModeFreqWire(device.i2c1.speed)); return;};
#endif
#if defined(RT_HW_PERMIT_I2C2)
if(bus==2){device.i2c2.speed=speed; Wire2.setClock(convertModeFreqWire(device.i2c2.speed)); return;};
#endif			
#endif		//--END #if defined(RT_HW_ARCH_AVR) || defined(RT_HW_ARCH_DUE) || defined(RT_HW_ARCH_ESP) || defined(RT_HW_ARCH_STM32)
//--------------------------------------------------------------------------------------------------	
};	//--END wireSetFreq(int8_t sda,int8_t scl, int8_t bus)

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						3. Начало передачи данных от master к slave 
//			(далее могут следовать команды write() одного из форматов)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: wireBeginTransmission(int8_t adr, uint8_t bus){
//-----Архитектуры AVR,DUE-------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C0)
if(bus==0){if((bitRead(device.i2c0.state, RT_HW_I2C_STATE_SLAVE)==0) && (adr>=0))  {Wire.beginTransmission(adr);}  return;};
#endif	
#if defined(RT_HW_PERMIT_I2C1)
if(bus==1){if((bitRead(device.i2c1.state, RT_HW_I2C_STATE_SLAVE)==0) && (adr>=0)); {Wire1.beginTransmission(adr);} return;};
#endif	
#if defined(RT_HW_PERMIT_I2C2)
if(bus==2){if((bitRead(device.i2c2.state, RT_HW_I2C_STATE_SLAVE)==0) && (adr>=0)); {Wire2.beginTransmission(adr);} return;};
#endif			
//--------------------------------------------------------------------------------------------------	
};	//--END  wireBeginTransmission(int8_t adr, int8_t bus)

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						4. Инициирование команды отправки по указанному адресу
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t RT_HW_BASE:: wireEndTransmission(uint8_t bus){
#if defined(RT_HW_PERMIT_I2C0)
if(bus==0){if((bitRead(device.i2c0.state, RT_HW_I2C_STATE_SLAVE)==0)) {return Wire.endTransmission();} else {return 4;}};
#endif	
#if defined(RT_HW_PERMIT_I2C1)
if(bus==1){if((bitRead(device.i2c1.state, RT_HW_I2C_STATE_SLAVE)==0)) {return Wire1.endTransmission();} else {return 4;}};
#endif	
#if defined(RT_HW_PERMIT_I2C2)
if(bus==2){if((bitRead(device.i2c2.state, RT_HW_I2C_STATE_SLAVE)==0)) {return Wire2.endTransmission();} else {return 4;}};
#endif	
//--------------------------------------------------------------------------------------------------	
return 4;}	//--END  wireEndTransmission(int8_t bus)


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						7. Поиск устройства на шине i2c 
//  Вход: id.adr-адрес устройства; bus-номер шины I2c(по умолчанию=0); id.custom->при инициализации установить =0; 
//		  id.maxErr - максимальное количество ошибок (1-255) - по умолчанию=20:
//		  id.maxOk  - кол-во успешных повторов, после которого устройство считается обнаруженным (1-31) - по умолчанию=3;	
//  Если устройство с заданныим адресом не найдено, то период поиска изменяется от 100мс до (100 х cntMax).
//	Если устройство найдено, то делаются дополнительные запросы через 50мс (всего должно быть три успешных попытки подряд);
//  Выход: успешный выход 		 ->cnt=0, функция возвращает 1;
//		   устройство не найдено ->cnt>1, функция возвращает 0;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//struct RT_HW_STRUCT_FIND_I2C{uint8_t custom=0;  uint8_t maxErr=20; uint8_t cntErr=0; uint8_t maxOk:4, cntOk:4; uint32_t timeDelay;}; 
bool RT_HW_BASE::findDeviceWire(RT_HW_STRUCT_FIND_I2C &id, uint8_t adr, uint8_t bus){
if(id.custom==0){return 0;}
if(id.custom==1){if((int8_t)adr<0)	  {id.custom=0; return 0;} if(id.maxErr==0){id.maxErr=20;} if(id.maxOk==0) {id.maxOk=3;} 				  
				 id.cntErr=id.cntOk=0; id.timeDelay=RT_HW_MILLIS; id.custom=2;}			//--Сброс и установка параметров;
if(id.custom==2){if(RT_HW_MILLIS < id.timeDelay) {return 0;} 							//--Ожидание по времени;
	wireBeginTransmission(adr,bus);														//--Отправка запроса на шину i2c;
	if(wireEndTransmission(bus)==0){id.cntErr=0; id.timeDelay=RT_HW_MILLIS+50;	//--Завершение после 
	if(++id.cntOk>3){id.custom=3; return 1;} else {return 0;}} 					//		многократного успешного поиска;
	id.cntOk=0; if(id.cntErr<id.maxErr) {id.cntErr++;}  						//--Обработка 
	id.timeDelay=RT_HW_MILLIS+(100*id.cntErr); return 0;} 						//	 ошибочной транзакции;
if(id.custom==3) {return 1;}
return 0;};		

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						6. Сканирование шины i2c (обнаружение подключенных устройств)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: scanDeviceWire(uint8_t bus){ if(consoleCheck()){
#if defined(RT_HW_PERMIT_I2C0)
if((bus==0) && (device.i2c0.adr==0)){uint8_t error; uint8_t qnt=0; consoleText(String(F("i2c0-> ")));	
wireBegin(device.i2c0.sda, device.i2c0.scl,0,bus); 
for(int i=1;i<=127;i++){wireBeginTransmission(i,bus); error=wireEndTransmission(bus);
if(error==0) {if(qnt){consoleChar(',');} qnt++; ConsoleVal('H',2,'/',i); consoleInt8(i);}}
consoleText(String(F("; qnt="))); consoleInt8(qnt,'I',';'); consoleCR();}
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C1)
if((bus==1) && (device.i2c1.adr==0)){uint8_t error; uint8_t qnt=0; consoleText(String(F("i2c1-> ")));	//--Вывод заголовка;  
wireBegin(device.i2c1.sda, device.i2c1.scl,0,bus); 
for(int i=1;i<=127;i++){wireBeginTransmission(i,bus); error=wireEndTransmission(bus);
if(error==0) {if(qnt){consoleChar(',');} qnt++; ConsoleVal('H',2,'/',i); consoleInt8(i);}}
consoleText(String(F("; qnt="))); consoleInt8(qnt,'I',';'); consoleCR();}
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C2)
if((bus==2) && (device.i2c2.adr==0)){uint8_t error; uint8_t qnt=0; consoleText(String(F("i2c2-> ")));	//--Вывод заголовка;  
wireBegin(device.i2c2.sda, device.i2c2.scl,0,bus); 
for(int i=1;i<=127;i++){wireBeginTransmission(i,bus); error=wireEndTransmission(bus);
if(error==0) {if(qnt){consoleChar(',');} qnt++; ConsoleVal('H',2,'/',i); consoleInt8(i);}}
consoleText(String(F("; qnt="))); consoleInt8(qnt,'I',';'); consoleCR();}
#endif
}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

