#include "RT_HW_BASE.h"	 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.1.Вывод даты и времени компиляции;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: ConsoleDataTime(){if(consoleCheck()){String str;
//------Вывод даты и времени-----------------------------------------------------------------------
str=__DATE__; consoleStr(str,';'); consoleBlank(59);
str=__TIME__; consoleStr(str,'E'); 
}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.1.Вывод наименования архитектуры и контроллера, номера библиотеки;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: ConsoleNameBoard(){ if(consoleCheck()){
//------Вывод наименований  архитектуры, платы, кода платы;
consoleText(String(F("Board:"))); 
consoleText(RT_HW_ARCH_NAME,'-'); consoleChar('>'); consoleText(RT_HW_BOARD_NAME,';'); 
consoleText(String(F(" Code:"))); consoleInt8(RT_HW_BOARD_DEFINED,'U','E');
//------Вывод идентификатора используемого ядра для STM32------------------------------------------
#if defined(RT_HW_ARCH_STM32MASTER)
consoleText(String(F("*** Ядро Arduino STM32-master")),'E');
#endif
#if defined(RT_HW_ARCH_STM32DUINO)
consoleText(String(F("*** Ядро Arduino STM32duino")),'E');	
#endif
#if defined(RT_HW_ARCH_STM32) &&(!defined(RT_HW_ARCH_STM32MASTER)) && (!defined(RT_HW_ARCH_STM32DUINO)) 
consoleText(String(F("*** Ядро для STM32 не идентифицировано")),'E');	
#endif
//------Вывод ограничений на функции ядра(контрлллеров)---------------------------------------------
#if !defined(RT_HW_ARCH_PERMIT_availableForWrite)
consoleText(String(F("*** Ограниченное использование функции Serialx.availableForWrite()->всегда возвращает 63")),'E');	
#endif
#if !defined(RT_HW_ARCH_PERMIT_WireSlave)
consoleText(String(F("*** Для шины i2c отсутствует режим Slave")),'E');	
#endif

//------Вывод частоты, напряжения процессора, имя файла с вариантом конфигурации, версии библиотеке- 
consoleText(String(F("Fcpu="))); consoleInt16(RT_HW_FCPU,'U','~'); consoleText(String(F("MHz")),';'); 
consoleText(String(F(" Vcc="))); consoleFloat((float)RT_HW_VCC/1000,'1',';'); 
consoleText(String(F(" Variant: "))); consoleText(RT_HW_BOARD_VARIANT,';'); 
consoleText(String(F(" Library:")));  consoleText(RT_HW_BASE_VER_NAME,'E');
//------Вывод размеров памяти, номера системных пинов control и ledBuiltin 
consoleText(String(F("Memory:")));	  consoleText(RT_HW_BOARD_MEMORY,';');  consoleBlank(2);
					      consoleText(String(F("Pins: control=")),'~'); consoleText(getNamePin(device.pin.control));
if(device.pin.led>=0)    {consoleText(String(F(",led=")));  		 	consoleText(getNamePin(device.pin.led));} 	  
if(device.pin.button>=0) {consoleText(String(F(",button=")));			consoleText(getNamePin(device.pin.button));}  
consoleSuff('E');
}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.2.Вывод системной разрядности контроллера и его устройств
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: ConsoleDepthBoard(){if(consoleCheck()){uint8_t qnt; 
if(device.depth.dac>0) {qnt=4;} else {qnt=3;}
consoleText(String(F("Depth:SYS,ADC,PWM"))); if(qnt==4) {consoleText(String(F(",DAC")));} consoleChar('=');
ConsoleV8x4('S',0,';',qnt,device.depth.sys, device.depth.adc, device.depth.pwm, device.depth.dac); 	consoleBlank(2);
consoleText(String(F("Drift ADC->current,null:"))); 
ConsoleV8x4('S',0,';',2,device.depth.drift, device.depth.vNull);	consoleBlank(2);
consoleText(String(F("SYS.max="))); 
ConsoleVal('S',0,';',maxBitDepth(device.depth.sys));  consoleCR();
}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.3.Вывод параметров i2c
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
void RT_HW_BASE::ConsoleParamWire(){if(consoleCheck()){ 							
//-----------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C0)
consoleText(String(F("i2c."))); 
if(bitRead(device.i2c0.state,RT_HW_I2C_STATE_SLAVE)) {consoleText(String(F("slave= "))); ConsoleVal('D',0,':',device.i2c0.adr);} 
												else {consoleText(String(F("master: ")));} 
consoleText(String(F(" SDA=")));  consoleText(getNamePin(device.i2c0.sda),',');	
consoleText(String(F(" SCL=")));  consoleText(getNamePin(device.i2c0.scl),',');	 
consoleText(String(F(" Freq="))); ConsoleVal('S',0,'~',convertModeFreqWire(device.i2c0.speed)/1000); consoleText(String(F("kHz;")));
#if defined(RT_HW_ARCH_ESP8266)
consoleText(String(F(" (для SDA,SCL допустимы пины D1-D10)")));
#endif
#if defined(RT_HW_ARCH_ESP32)  
consoleCR(); consoleBlank(12); consoleText(String(F(" Для SDA,SCL допустимы пины <=34.Pежим Slave не поддерживается.")));
#endif
#if defined(RT_HW_ARCH_STM32)
consoleText(String(F(" (для SDA,SCL допустимы пины PB7,PB6 или PB9,PB8)")));  
#endif
consoleCR();
#endif 
//-----------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C1)
if(bitRead(device.i2c1.state,RT_HW_I2C_STATE_SLAVE)) {consoleText(String(F("slave= "))); ConsoleVal('D',0,':',device.i2c1.adr);} 
												else {consoleText(String(F("master: ")));} 
consoleText(String(F(" SDA=")));  consoleText(getNamePin(device.i2c1.sda),',');	
consoleText(String(F(" SCL=")));  consoleText(getNamePin(device.i2c1.scl),',');	 
consoleText(String(F(" Freq="))); ConsoleVal('S',0,'~',convertModeFreqWire(device.i2c1.speed)/1000); consoleText(String(F("kHz;")));
consoleCR();
#endif 
#if defined(RT_HW_PERMIT_I2C2)
if(bitRead(device.i2c2.state,RT_HW_I2C_STATE_SLAVE)) {consoleText(String(F("slave= "))); ConsoleVal('D',0,':',device.i2c2.adr);} 
												else {consoleText(String(F("master: ")));} 
consoleText(String(F(" SDA=")));  consoleText(getNamePin(device.i2c2.sda),',');	
consoleText(String(F(" SCL=")));  consoleText(getNamePin(device.i2c2.scl),',');	 
consoleText(String(F(" Freq="))); ConsoleVal('S',0,'~',convertModeFreqWire(device.i2c2.speed)/1000); consoleText(String(F("kHz;")));
consoleCR();
#endif  
}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.4.Вывод параметров SPI
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: ConsoleParamSPI(){ if(consoleCheck()){
#ifdef RT_HW_PERMIT_SPI0
consoleText(String(F("SPI-->SS,MOSI,MISO,SCK: "))); 
consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 0)), ',');
consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 1)), ',');
consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 2)), ',');
consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 3)), 'E');
#endif 
#ifdef RT_HW_PERMIT_SPI1
consoleText(String(F("SPI1->SS,MOSI,MISO,SCK: "))); 
consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 4)), ',');
consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 5)), ',');
consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 6)), ',');
consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 7)), 'E');
#endif
#ifdef RT_HW_PERMIT_SPI2
consoleText(String(F("SPI2-->SS,MOSI,MISO,SCK: "))); 
consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 8)), ',');
consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_SPI_ID, 9)), ',');
consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_SPI_ID,10)), ',');
consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_SPI_ID,11)), 'E');
#endif 
}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.5.Вывод параметров UART
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#define RT_HW_PRINT_NUM_UART 6		//---Макс. кол-во выводимых UART в одной строке
void RT_HW_BASE:: ConsoleParamUART(){ if(consoleCheck()){uint8_t cnt=0;
consoleText(String(F("UART(RX,TX)->")));		//--Вывод заголовка; 
#ifdef RT_HW_PERMIT_UART0
cnt++;	consoleText(String(F(" UART: ")));  consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_UHS_ID, 0)), ','); consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_UHS_ID, 1)), ';');		  
#endif
#ifdef RT_HW_PERMIT_UART1
cnt++;	consoleText(String(F(" UART1: "))); consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_UHS_ID, 2)), ','); consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_UHS_ID, 3)), ';');	
#endif
#ifdef RT_HW_PERMIT_UART2
cnt++;	consoleText(String(F(" UART2: "))); consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_UHS_ID, 4)), ','); consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_UHS_ID, 5)), ';');	 
#endif
#ifdef RT_HW_PERMIT_UART3
cnt++;	consoleText(String(F(" UART3: "))); consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_UHS_ID, 6)), ','); consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_UHS_ID, 7)), ';'); 	
#endif
#ifdef RT_HW_PERMIT_UART4
if(++cnt>=RT_HW_PRINT_NUM_UART) {cnt=0;    consoleCR(); consoleBlank(13);}; 
        consoleText(String(F(" UART4: "))); consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_UHS_ID, 8)), ','); consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,9)), ';');
#endif
#ifdef RT_HW_PERMIT_UART5
if(++cnt>=RT_HW_PRINT_NUM_UART) {cnt=0;    consoleCR(); consoleBlank(13);}; 
        consoleText(String(F(" UART5: "))); consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,10)), ','); consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,11)), ';');
#endif
#ifdef RT_HW_PERMIT_UART6
if(++cnt>=RT_HW_PRINT_NUM_UART) {cnt=0;    consoleCR(); consoleBlank(13);}; 
        consoleText(String(F(" UART6: "))); consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,12)), ','); consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,13)), ';');
#endif
#ifdef RT_HW_PERMIT_UART7
if(++cnt>=RT_HW_PRINT_NUM_UART) {cnt=0;    consoleCR(); consoleBlank(13);}; 
        consoleText(String(F(" UART7: "))); consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,14)), ','); consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,15)), ';');
#endif
#ifdef RT_HW_PERMIT_UART8
if(++cnt>=RT_HW_PRINT_NUM_UART) {cnt=0;    consoleCR(); consoleBlank(13);}; 
        consoleText(String(F(" UART8: "))); consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,15)), ','); consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_UHS_ID,17)), ';');
#endif
#ifdef RT_HW_PERMIT_UARTS
if(++cnt>=RT_HW_PRINT_NUM_UART) {cnt=0;    consoleCR(); consoleBlank(13);}; 
        consoleText(String(F(" UARTS: "))); consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_USS_ID, 0)), ','); consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_USS_ID, 1)), ';');
#endif
consoleCR();	
}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.6. Вывод параметров CAN
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: ConsoleParamCAN(){
#ifdef RT_HW_PERMIT_CAN
if(consoleCheck()){consoleText(String(F("CAN (RX,TX)-> "))); 
consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_CAN_ID, 0)), ',');
consoleText(getNamePin(getIntPGM(RT_HW_PGM_PIN_CAN_ID, 1)), 'E');}
#endif
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.7. Вывод параметров BlueTooth
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: ConsoleParamBTH(){
#ifdef RT_HW_PERMIT_BTH
if(consoleCheck()){consoleText(String(F("BlueTooth->в разработке:"))); 
consoleChar((char)getIntPGM(RT_HW_PGM_PIN_BTH_ID,0));
consoleChar((char)getIntPGM(RT_HW_PGM_PIN_BTH_ID,1));
consoleChar((char)getIntPGM(RT_HW_PGM_PIN_BTH_ID,2));
consoleSuff('E');}
#endif
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.8. Вывод параметров Ethernet
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: ConsoleParamETH(){
#ifdef RT_HW_PERMIT_ETH
if(consoleCheck()){consoleText(String(F("Ethernet->в разработке:"))); 
ConsoleVal('S',0,'.',getUintPGM(RT_HW_PGM_PIN_ETH_ID,0));
ConsoleVal('S',0,'.',getUintPGM(RT_HW_PGM_PIN_ETH_ID,1));
ConsoleVal('S',0,'.',getUintPGM(RT_HW_PGM_PIN_ETH_ID,2));
ConsoleVal('S',0,'E',getUintPGM(RT_HW_PGM_PIN_ETH_ID,3));}
#endif
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.6. Вывод параметров Wi-Fi
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: ConsoleParamWFI(){
#ifdef RT_HW_PERMIT_WFI
if(consoleCheck()){consoleText(String(F("Wi-Fi(в разработке)->:"))); 
ConsoleVal('S',0,'.',getUintPGM(RT_HW_PGM_PIN_WFI_ID,0));
ConsoleVal('S',0,'.',getUintPGM(RT_HW_PGM_PIN_WFI_ID,1));
ConsoleVal('S',0,'.',getUintPGM(RT_HW_PGM_PIN_WFI_ID,2));
ConsoleVal('S',0,'E',getUintPGM(RT_HW_PGM_PIN_WFI_ID,3));}
#endif
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						2. Вывод доступных пинов контроллера 
//  	mode='A' ->  вывод всех элементов в формате int8_t 	с форматированием;
//		mode='B' ->  вывод всех элементов в формате uint8_t c форматированием;
//		mode='U' ->  вывод всех элементов в формате uint8_t c форматированием до трех знаков (вывод байтов);
//		mode='C' ->  вывод элементов 0-127, вместо остальных элементов выводятся заполнители;
//      mode='D' ->  вывод элементов 0-127, остальные элементы не выводятся;
//  	mode='S' ->  вывод всех элементов в формате int8_t без форматирования;
//      mode='P' ->  вывод в формате пинов(для ESP8266,STM32 в текстовой форме),вместо отсутствующих пины(=-1) выводится заполнитель;
//      mode='N' ->  ничего не выводится;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-----Системные параметры-------------------------------------------------------------------------
void RT_HW_BASE:: ConsoleSysParam	(char mode){if(consoleCheck()){for(uint8_t i=0;i<=RT_HW_PGM_SYS_DAC_ID;i++){ConsoleArrPGM(i,mode);}}};
//-----Системные пины------------------------------------------------------------------------------
void RT_HW_BASE:: ConsoleSysPins	(char mode){if(consoleCheck()){ConsoleArrPGM(RT_HW_PGM_SYS_PIN_ID,mode);}};		
//-----Интерфейсные пины---------------------------------------------------------------------------
void RT_HW_BASE:: ConsoleLinkPins	(char mode){if(consoleCheck()){for(uint8_t i=RT_HW_PGM_PIN_I2C_ID;i<=RT_HW_PGM_PIN_CAN_ID;i++){ConsoleArrPGM(i,mode);}}};
//-----Сетевые параметры---------------------------------------------------------------------------
void RT_HW_BASE:: ConsoleNetParam	(char mode){if(consoleCheck()){for(uint8_t i=RT_HW_PGM_PIN_BTH_ID;i<=RT_HW_PGM_PIN_WFI_ID;i++){ConsoleArrPGM(i,mode);}}};
//-----Пины контроллера----------------------------------------------------------------------------
void RT_HW_BASE:: ConsolePinsBoard  (char mode){if(consoleCheck()){for(uint8_t i=RT_HW_PGM_PIN_ALL_ID;i<=RT_HW_PGM_PIN_N5V_ID;i++){ConsoleArrPGM(i,mode);}
if(getLenPosPGM(RT_HW_PGM_PIN_N5V_ID)==0) {consoleText(String(F("All pins tolerant to 5V")),'E'); }; 
}};	
//-----Тестовые пины------------------------------------------------------------------------------- 
void RT_HW_BASE:: ConsolePinsTest	(char mode){if(consoleCheck()){for(uint8_t i=RT_HW_PGM_PIN_DBG_ID;i<=RT_HW_PGM_PIN_SSP_ID;i++){ConsoleArrPGM(i,mode);}}};	
//-----Адреса устройства(i2c  и др.)--------------------------------------------------------------- 
void RT_HW_BASE:: ConsoleAdrTest	(char mode){if(consoleCheck()){ConsoleArrPGM(RT_HW_PGM_ADR_I2C_ID,mode);}};

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						3. Вывод наименование пинов (ESP8266,STM32) 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: ConsoleNamePins(){						
#if defined(RT_HW_ARCH_ESP8266) 
consoleText(RT_HW_BOARD_NAME_PINS_ESP8266_1,'L');
consoleText(RT_HW_BOARD_NAME_PINS_ESP8266_2,'L');
#endif
#if defined(RT_HW_ARCH_STM32)
ConsoleTablePinsSTM32();
#endif
};

//-----На проверка на наличие не нулевых пинов (до 4-х)--------------------------------------------
bool RT_HW_BASE:: checkPinx4(uint8_t qnt, int8_t v1,int8_t v2, int8_t v3, int8_t v4){
if(qnt>=1) {if((int8_t)v1>=0){return 1;}}
if(qnt>=2) {if((int8_t)v2>=0){return 1;}}
if(qnt>=3) {if((int8_t)v3>=0){return 1;}}
if(qnt>=4) {if((int8_t)v4>=0){return 1;}}
return 0;}
//-----Вывод до 4-х пинов--------------------------------------------------------------------------
void RT_HW_BASE::ConsolePinx4(uint8_t qnt, int8_t v1,int8_t v2, int8_t v3, int8_t v4){if(consoleCheck()){
	                        //RT_HW_Base.ConsoleText('C',80,'L','-',String(F("Сканирование шины i2c")));
if(qnt>=1) {							 ConsoleText('L',RT_HW_PIN_TXT_LEN,'~',' ',getNamePin(v1));} 
if(qnt>=2) {RT_HW_Base.consoleSuff(','); ConsoleText('L',RT_HW_PIN_TXT_LEN,'~',' ',getNamePin(v2));} 
if(qnt>=3) {RT_HW_Base.consoleSuff(','); ConsoleText('L',RT_HW_PIN_TXT_LEN,'~',' ',getNamePin(v3));} 
if(qnt>=4) {RT_HW_Base.consoleSuff(','); ConsoleText('L',RT_HW_PIN_TXT_LEN,'~',' ',getNamePin(v4));} 
//if(qnt>=1) {
	consoleSuff('E');
}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						6. Сканирование шины i2c (обнаружение подключенных устройств)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: ConsoleScanWire(uint8_t bus){ if(consoleCheck()){
#if defined(RT_HW_PERMIT_I2C0)
if((bus==0) && (device.i2c0.adr==0)){uint8_t error; uint8_t qnt=0; consoleText(String(F("i2c0-> ")));	
wireBegin(device.i2c0.sda, device.i2c0.scl,0,bus); 
for(int i=1;i<=127;i++){wireBeginTransmission(i,bus); error=wireEndTransmission(bus);
if(error==0) {if(qnt){consoleChar(',');} qnt++; ConsoleVal('H',2,'/',i); consoleInt8(i);}}
consoleText(String(F("; qnt="))); consoleInt8(qnt,'I',';'); consoleCR();}
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C1)
if((bus==1) && (device.i2c1.adr==0)){uint8_t error; uint8_t qnt=0; consoleText(String(F("i2c1-> ")));	//--Вывод заголовка;  
wireBegin(device.i2c1.sda, device.i2c1.scl,0,bus); 
for(int i=1;i<=127;i++){wireBeginTransmission(i,bus); error=wireEndTransmission(bus);
if(error==0) {if(qnt){consoleChar(',');} qnt++; ConsoleVal('H',2,'/',i); consoleInt8(i);}}
consoleText(String(F("; qnt="))); consoleInt8(qnt,'I',';'); consoleCR();}
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C2)
if((bus==2) && (device.i2c2.adr==0)){uint8_t error; uint8_t qnt=0; consoleText(String(F("i2c2-> ")));	//--Вывод заголовка;  
wireBegin(device.i2c2.sda, device.i2c2.scl,0,bus); 
for(int i=1;i<=127;i++){wireBeginTransmission(i,bus); error=wireEndTransmission(bus);
if(error==0) {if(qnt){consoleChar(',');} qnt++; ConsoleVal('H',2,'/',i); consoleInt8(i);}}
consoleText(String(F("; qnt="))); consoleInt8(qnt,'I',';'); consoleCR();}
#endif
}};



/*
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	Вывод на консоль отформатированный вывод пина с суффиксом по его номеру
//		для ESP8266 - в формате D0-D8,RX,TX,A0;
//		для STM32	- в формату Pxx (PA0,PA15,PB0,PB15 и т.д.)
//	Если номер pin не допустим для контроллера, выводится символ '*'.
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printPin(int8_t pin, char suff){
#if defined(RT_HW_ARCH_ESP8266)	
printTextStr(getNamePinESP8266(pin),RT_HW_PIN_TXT_LEN,'L',' ',suff); return;

if(pin==D0) {printTextStr("D0",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==D1) {printTextStr("D1",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==D2) {printTextStr("D2",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==D3) {printTextStr("D3",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==D4) {printTextStr("D4",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==D5) {printTextStr("D5",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==D6) {printTextStr("D6",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==D7) {printTextStr("D7",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==D8) {printTextStr("D8",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==RX) {printTextStr("RX",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==TX) {printTextStr("TX",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
if(pin==A0) {printTextStr("A0",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;}
			 {printTextStr ("-",RT_HW_PIN_TXT_LEN,'R',' ',suff); return;} 			 
#elif defined(RT_HW_ARCH_STM32)			 
printTextStr(getNamePinSTM32(pin),RT_HW_PIN_TXT_LEN,'L',' ',suff); return;
#else
if(pin>=0)  {printVal('I',RT_HW_PIN_TXT_LEN,suff,pin);} else {printBlank((RT_HW_PIN_TXT_LEN-1),' ','*'); printSuff(suff);}; return;	
#endif		
}
*/
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++