/*******************************************************************************
Библиотека для семейства ультразвуковых дальномеров типа HC-SR04
	 в системах реального времени типа 
		
++++++++++++++++++++++++ Данные библиотеки +++++++++++++++++++++++++++++++++++++
Версия 2.0
Текущая   версия  2018-06-04
Начальная версия  2018-02-11
Разработчик ООО "ЭкоИнформСистема" ecoins@mail.ru
 с использованием идей библиотеки NewPing.hc
   Project home: https://bitbucket.org/teckel12/arduino-new-ping/wiki/Home
   Blog: http://arduino.cc/forum/index.php/topic,106043.0.html
   
+++++++++++++++++++++++++ Возможности ++++++++++++++++++++++++++++++++++++++++++
  - поддержка HC-SR04 и их аналогов;
  - работа на одном пине - выходы ECHO и TRIG сенсора соединены через 
        резистор 2ком, контроллер  подключается к контакту Trig;
  - могут работать на пинах с аппаратным прерыванием и на пинах без прерываний
  - задержка по времени  на пинах с аппаратным прерыванием не болле 400-700 мкс;
  - на пинах без аппаратного прерывания задержка увеливается на 
     время(мкс)=расстояние(см)*58 
     Например  20см х  58 = 1160мкс + 500мкс=1,6мс.
               60см х  58 = 3480мкс + 500мкс=4мсж;
  - максимальное расстояние может задаваться пользователем.
  
+++++++++++++++++++++++++ Описание конструкции HC-SR04 ++++++++++++++++++++++++++
Дальномер имеет собственный микроконтроллер который отрабатывает определенный 
алгоритм, с учетом которого библиотекой через контакт Trig запускается звуковой импульс
и через контакт Echo считывается ответный импульс от отраженного предмета 
После запуска импульса не ранее 200 мкс и не позднее 700мкс на пине должен 
     появиться высокий уровень, что означает начало ожидания ответного ЭХО на пине.
+++++++++++++++++++++++++ Основные принципы +++++++++++++++++++++++++++++++++++++       
В библиотеке создано восемь обработчиков(0-7) (можно увеличить) для пинов с аппаратными прерыванями.

Для каждого сонара создается объект. По умолчанию номер пина=99, измеренное расстояние 99см. 
Метод config(pin) определяет наличие аппаратного прерывания на пине и наличие свободного обработчика, 
который привязываются к пину. 

Если пин без аппаратного прерывания или заняты все обработчики, объект настраивается для работы без прерывания.

Кол-во объектов (сонаров) не ограничено, но только до восьми из них могут  работать с аппаратными прерываниями.  


В библиотеке создано восемь обработчиков(0-7), в которых хранятся номера векторов прерывания 
и флаги запуска/завершения измерения.
        
        Плата                int.0  int.1  int.2  int.3  int.4  int.5
        UNO, Nano, Ethernet    2      3	 	 	 	 
        Mega2560	       2      3      21	    20	  19	18
        Leonardo	       3      2       0	     1	   7	
        ESP8266               на всех пинах (кроме GPI016) и номер прерывания совпадает с номером пина 
        DUE                   на всех пинах                  номер прерывания совпадает с номером пина 

Пример для Arduino Nano: 
  RT_SR04_v2 sonar_0;  //  
  RT_SR04_v2 sonar_1;  // пин 3, int.1
  RT_SR04_v2 sonar_2;  // пин 4, будет работать без прерывания
  RT_SR04_v2 sonar_3;  // пин 5, будет работать без прерывания


+++++++++++++++++++++++ Vtnjlsдоступные пользователю +++++++++++++++++++++++++++++++++
 xxx.config(pin)      - настройка объекта на указанный пин.Если нет условий (пин без аппаратного прерывания)
                        или заняты все восемь обработчиков, настраивается режим без обработки прерывания
 xxx.config(pin,0)    - настройка объекта без обработки прерывания
 xxx.meter()          - вызывается периодически. 
                        В системах типа RT_EIS это могут быть быстрые или медленные задачи. 
 xxx.getDistanceCm()  - возвращает дистанцию в см
 xxx.getDistanceMcs() - возвращает дистанцию в mcs
 xxx.getError()	      - возвращает код ошибки  
 xxx.getVer()         - возвращает 
 xxx.setDistance(uint16_t distance) - устанавливается новая дистанция (не более 500см) 

+++++++++++++++++++++++ Коды ошибок ++++++++++++++++++++++++++++++++++++++++++++++++++++
  error=0 - начало измеряемого импульса на ECHO
  error=1 - высокий уровень на пине перед подачей на него импульса (отсутствие сенсора); maxTime-->meterTime
  error=2 - после запуска импульса не появился низкий уровень (неисправность сенсора);         0-->meterTime
  error=3 - не появляется измеряемый импульс на ECHO в течении 700мкс (при расстоянии меньше 1см); 0-->meterTime


***************************************************************************************/