//======================================================
//          Тест библиотеки RT_HW_DHTx 
//            для сенсора типа DHT22
//         (адаптирована для работы с FLProg)
//======================================================
#define RT_HW_DHT_pinDHT_1       3    //--Номер пина с подключенным сенсором DHT
#define RT_HW_DHT_periodPoll_1  -1    //--Период опроса
#define RT_HW_DHT_pinDHT_2       4    //--Номер пина с подключенным сенсором DHT
#define RT_HW_DHT_periodPoll_2   2200 //--Период опроса

#define RT_HW_DHT_pinControl 13   //--Номер контрольного пина 
//======================================================
#include "RT_HW_DHTx.h"
RT_HW_DHTx_ID dht1,dht2;
bool blink;
bool EN1,EN2;   //--Внешний сигнал разрешения опроса
//=====================================================
void setup() {
  Serial.begin(115200);
  pinMode(13,OUTPUT);
  EN1=EN2=1;
}
//======================================================
void loop() {
blink=!blink; digitalWrite(RT_HW_DHT_pinControl,blink);
//-----------------Измерение dht1-----------------------
switch(dht1.dir){default: 
  case 1: break;  
  case 0: RT_HW_dhtX.setID_device(dht1,RT_HW_DHT_pinDHT_1,RT_HW_DHT_periodPoll_1);    		//--Настройка сенсорв 
  case 2: dht1.run=0; RT_HW_dhtX.makeRun_device (dht1,EN1); RT_HW_dhtX.meter(dht1); break;}	//--Завершение опроса 
if(dht1.fresh){dht1.fresh=0;                                                                //--Вывод параметров на монитор
  Serial.println(String(F("dht1->t=")) +String(dht1.temperature,2)+String(F("; h="))      +String(dht1.humidity,2)+ String(F("; cnt="))+String(dht1.cntMeter) 
                +String(F("; cntErr="))+String(dht1.cntErr)       +String(F("; codeErr="))+String(dht1.codeErr));}
//-----------------Измерение dht2-----------------------
switch(dht2.dir){default: 
  case 1: break;  
  case 0: RT_HW_dhtX.setID_device(dht2,RT_HW_DHT_pinDHT_2, RT_HW_DHT_periodPoll_2); break;    //--Настройка сенсорв 
  case 2: dht2.run=0; RT_HW_dhtX.makeRun_device (dht2,EN2);   RT_HW_dhtX.meter(dht2); break;} //--Завершение опроса 
if(dht2.fresh){dht2.fresh=0;                                                                  //--Вывод параметров на монитор
  Serial.println(String(F("dht2->t=")) +String(dht2.temperature,2)+String(F("; h="))      +String(dht2.humidity,2)+ String(F("; cnt="))+String(dht2.cntMeter) 
                +String(F("; cntErr="))+String(dht2.cntErr)       +String(F("; codeErr="))+String(dht2.codeErr));}             
} //--END loop()
