#include "RT_HW_DS1820.h"
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	1.1. Конструктор
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RT_HW_DS1820::RT_HW_DS1820() {}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	1.2 Генератор меандра 50 мс и флага перезапуска устройства (periodReboot в тиках=50мс)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void RT_HW_DS1820:: genEventID(RT_HW_DS1820_ID &id){id.event=0; if(RT_HW_DS1820_MILLIS>=id.timeStart) {id.event=1; id.blink=!id.blink; id.timeStart=RT_HW_DS1820_MILLIS+RT_HW_DS1820_PERIOD_TICK;}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	1.3. Настройка параметров устройства
// t_sb(период опроса)  =0: 0.5ms; =1: 62.5ms; =2: 125ms; =3: 250ms; =4: 500ms; =5: 1000ms; =6: 10ms; =7: 20ms;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_DS1820:: setID(RT_HW_DS1820_ID &id, int8_t addr, uint16_t period){
if(id.custom==1) {return;} id.custom=1; 
//----Установка внешних параметров
if(period>1000) {id.period=period;} else {id.period=1000;}
//----Начальная установка параметров
id.codeErr=id.permit=0; id.T=-0.1;	id.fresh=1;	id.first=1;		

//----Определение периодов опроса и допустимой ошибки----------------------------------------------
id.cntErr=0; 										//--Очистка счетчиков;
id.eventMeter=1;	
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	1.4. Управление устройством
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_DS1820:: directDevice(RT_HW_DS1820_ID &id){
//----Установка флага периодического запуска
if((RT_HW_DS1820_MILLIS-id.timeStart)>=id.period) {id.event=1; id.timeStart=RT_HW_DS1820_MILLIS+id.period;} 

//----Установка флагов запуска по времени----------------------------------------------------------
//if(id.event){if(id.periodTemper){if(id.periodTemper < 5) {id.periodTemper =5;}
//			 if(++id.cntTemper > id.periodTemper) {id.cntTemper=1; if(id.periodTemper) {id.eventTemper =1;}}
//			 if(++id.cntErr    > id.periodErr)    {id.cntErr=1; id.err=1; id.T=-0.1; id.fresh=1;}} else {id.eventTemper=0; id.T=-0.1; id.fresh=1;}}
//----Ожидание флага запуска измерения id.eventTemper----------------------------------------------
if(id.stepDirect==0){if(id.event) {if(id.permit) {id.blink=!id.blink; id.event=0; id.eventMeter=1;}} 
					 if(id.eventMeter) {id.stepDirect++;} else {return;}}
//----Чтение сенсора ------------------------------------------------------------------------------
if(id.stepDirect==1){ 
					// if(id.rawData==0)			{id.codeErr=1;  id.stepDirect=0;  return;} //--Выход, ошибочное измерение;
					// if(bitRead(id.rawData,2))	{id.codeErr=2;  id.stepDirect=0; return;} //--Выход, если обрыв термопары;
					// id.adcData=id.rawData>>3; 												//--Контрольное чтение.				 
					 //-------------------------------------------------------------------------------------------
					// if(id.filter){if(id.first) {id.first=0; id.averageData=0;
					//			   for(uint8_t i=0; i<RT_HW_DS1820_SIZE_BUFF; i++){id.buff[i]=id.adcFilterData=id.adcData; id.averageData=id.averageData+id.adcData;}}
					//			   id.T= 0;
								  /*
								   Serial.print(F("id.filter=")); Serial.print(id.filter);
								   Serial.print(F(" adcData=")); Serial.print(id.adcData);
								   Serial.print(F(" adcFilterData=")); Serial.print(id.adcFilterData);
								   Serial.print(F(" middleFilterData=")); Serial.print(id.middleFilterData);
								   Serial.print(F(" buff[0-3]->"));  
								   Serial.print(id.buff[0]); Serial.print(','); Serial.print(id.buff[1]); Serial.print(',');
								   Serial.print(id.buff[2]); Serial.print(','); Serial.print(id.buff[3]); Serial.print(' ');
								   Serial.print(F("  T="));  Serial.print(id.T,2);  Serial.print('\n');
								  */
					//			   }
								   
					 //else		  {}				   
					 id.fresh=1; id.err=0; id.codeErr=0; id.cntErr=0; 
					 id.stepDirect=0; return;}  
					 };
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++					 			 
//=================================================================================================	
RT_HW_DS1820 RT_HW_ds1820; //--Создание объекта 

