/*** FLProg ************** Библиотека RT_HW_DS1820 ver0.1 для Arduino ***************
Измерение температуры ds1820 
  ecoins@mail.ru 08.08.2020г.
**************************************************************************************************/
//#################################################################################################
#ifndef RT_HW_MAX6675_h
#define RT_HW_MAX6675_h
//-------------------------------------------------------------------------------------------------
#if defined(ARDUINO) && ARDUINO >= 100 
#include <Arduino.h>
#else
#include <WProgram.h>
#endif
//-------------------------------------------------------------------------------------------------
#include "OneWire.h"
//-------------------------------------------------------------------------------------------------
#define RT_HW_DS1820_VERSION 				01			//--Номер версии библиотеки
#define RT_HW_DS1820_PERIOD_TICK  			50			//--Период системного времени в ms;
#define RT_HW_DS1820_MILLIS				millis()	//--Время в миллисекундах;
//-------------------------------------------------------------------------------------------------							   							
struct RT_HW_DS1820_ID {
	uint32_t timeStart;
	int8_t  addr=-1;
	uint16_t period;
	
	uint8_t codeErr, cntErr, stepDirect, cntTemper,  periodTemper, periodErr;
	uint16_t custom:1, permit:1, ban:1, event:1, blink:1, eventMeter:1, fresh:1, err:1, first:1, filter:1, test:1, index:2;
	uint16_t  adcData;
	int32_t   averageData;
	float 	  T;
	};							
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                     КЛАСС УПРАВЛЕНИЯ LCD
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class RT_HW_DS1820{
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//         СТРУКТУРЫ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++				 
//---------------------------------------------------------------------------------------
public: 
RT_HW_DS1820();										//--Конструктор;
void	genEventID		(RT_HW_DS1820_ID &id);
void	setID       	(RT_HW_DS1820_ID &id, int8_t addr, uint16_t period);
void	directDevice	(RT_HW_DS1820_ID &id);
};//==============  Конец класса ==================================================================
extern RT_HW_DS1820 RT_HW_ds1820; //--Внешняя ссылка на объект;
#endif
