/**************************************************************************************************
 *       БИБЛИОТЕКА ДЛЯ РАБОТЫ С МОДЕЛЯМИ АВТОМОБИЛЕЙ
 *************************************************************************************************/
#ifndef RT_HW_CAR_h
#define RT_HW_CAR_h

#if defined(ARDUINO) && (ARDUINO >= 100)
#include <Arduino.h>
#else
#include <WProgram.h>
#endif
//-------------------------------------------------------------------------------------------------
#include "RT_HW_BASE.h"						//--Подключение базовой библиотеки;
#define RT_HW_CAR_VER			01			//--Номер версии библиотеки;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	СТРУКТУРА RT_HW_CAR_ID- параметры устройства ;	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct  RT_HW_CAR_DRIVE_ID{   //--16 байт
uint8_t dir, step; 
uint16_t period; 
uint32_t timeStart;
struct {uint8_t factor; uint16_t Max,Min; uint16_t space,set,add,cur,left,right; uint8_t motor;} power;
struct {uint16_t stop, drive, small;} delta;
struct {char set; char cur='S';} cmnd;		  				   
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	СТРУКТУРА RT_HW_CAR_ID- параметры устройства ;	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct  RT_HW_CAR_REMOTE_CONTROL_ID{
uint16_t direct, speed; char sign,cmnd; uint8_t dir,cnt; uint32_t timeStart;  		  				   
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		КЛАСС: RT_HW_CAR
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class RT_HW_CAR{
public:
RT_HW_CAR(); 	//--Конструктор;
void setID(RT_HW_CAR_DRIVE_ID &id, uint16_t period, uint8_t factor, uint16_t Max, uint16_t Min);	//--Установка параметров;
void direct(RT_HW_CAR_DRIVE_ID &id, char cmnd,       uint8_t speed,  bool block, bool fast);		//--Управление моторами;
void convert(RT_HW_CAR_DRIVE_ID &id, bool fast=0);   //--Расчет текущей мощности моторов;
                      // RT_HW_CAR_REMOTE_CONTROL_ID &id, int8_t uart, uint16_t timeOut){
void readRemoteControl(RT_HW_CAR_REMOTE_CONTROL_ID &id, int8_t uart, uint16_t timeOut);
void convertRemoteControl(RT_HW_CAR_REMOTE_CONTROL_ID &id, char sign);
};  //---END 
//==============  Конец класса ======================================================
extern RT_HW_CAR RT_HW_Car; //--Создание объекта 
//===================================================================================
#endif //---RT_HW_CAR_h


