/**************************************************************************************************
  Тестирование некоторых функций  библиотеки RT_HW_NEXT.h 
                    (работа с дисплеем Nextion)
   1.Библиотека позволяет работать до 8-ми одновременных подключенных к разным UART дисплеев;
   2.Тестируется для 6-ти создаваемых id дисплеев;
   3.Для каждого созданного устройства создается уникальный номер zx.num(от 1 до 8).
     Недопустимые или несущестующие устройства имеют номер=0;    
   4.Для каждого устройства создаются три типа массивов (uint8_t, uint16_t, uint32_t)
   5.Тестируются функции записи и чтения массивов с учетом возможных ошибочных параметров :
     5.1.Обращение к массивам несуществующего устройства;
     5.2.Обращение к несуществующему элементу массива.
***************************************************************************************************/
#include "RT_HW_NEXT.h"     //--Включает вызов RT_HW_BASE.h;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//         Определение переменных, используемых в тесте
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t vInit = 0;                                                  //--Параметр для инициализации параметров
bool headConsole;                                                   //--Флаг разрешения вывода на консоль заголовков; 
uint8_t numQuick, numFast, numSlow, numBack, numFrdm;               //--Номера задач для диспетчера задач;
uint8_t  pinControl, pinLedBoard, pinButton, pinADC, pinPWM, pinLed;//--Тестовые пины;
uint8_t  pinSPI_595, pinSPI_lcd;                                    //--Тестовые пины устройств SPI;
uint8_t i2c_lcd1,i2c_lcd2,i2c_mcp1,i2c_mcp2;                        //--Адреса устройств i2c;
RT_HW_PIN_DIR_ID idControl,idLedBoard,idButton,idADC,idPWM,idLed;   //--id устройств, связанных с пинами;
uint8_t okNext,okTest;
uint8_t dirNext=0;
float dhtT=20.0;
float dhtH=75.0;
float dsT=-10.0;
String str;
uint32_t in0,in10;
int8_t numUart=1;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//         Определение параметров для работы с устройтсвами Nextion
//  Шесть id устройств, для каждого по создаются три типа массивов (uint8_t,uint16_t,uint32_t)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RT_HW_NEXT_DEVICE_ID z1,z2,z3,z4,z5,z6;
uint8_t  arrByte_z1[6]={ 12, 34, 56,78,87,92};  uint16_t arrWord_z1[4]={10101,11202,12303,13404}; uint32_t arrLong_z1[4]= {650101,66202,67303,68404}; 
uint8_t  arrByte_z2[4]={ 90,102,113,125};       uint16_t arrWord_z2[4]={20101,21202,22303,23404};  uint32_t arrLong_z2[3]={750101,76202,77303}; 
uint8_t  arrByte_z3[3]={136,158,190};           uint16_t arrWord_z3[4]={30101,31202,32303,33404};  uint32_t arrLong_z3[5]={850101,86202,87303,88404, (uint32_t)-234567}; 
uint8_t  arrByte_z4[2]={235,(uint8_t)-103};     uint16_t arrWord_z4[4]={40101,41202,42303,43404};  uint32_t arrLong_z4[6]={950101,96202,97303,98404, (uint32_t)-27, 49}; 
uint8_t  arrByte_z5[1]={(uint8_t)-6};           uint16_t arrWord_z5[4]={50101,51202,52303,53404};  uint32_t arrLong_z5[1]={990101}; 
uint8_t  arrByte_z6[1]={1};                     uint16_t arrWord_z6[1]={2};                        uint32_t arrLong_z6[1]={4}; 
//=================================================================================================
#include "NextArrTest.hpp"  //--
//=================================================================================================
void setup() {okNext= okTest=z1.dir=z2.dir=z3.dir=z4.dir=z5.dir=0;}
//=================================================================================================
void loop() {
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//         ИНИЦИАЛИЗАЦИЯ (выполняется одие раз)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if(vInit == 0) {vInit = 1; 
pinControl  =RT_HW_Base.device.pin.control;
pinLedBoard =RT_HW_Base.device.pin.led;
pinADC      =RT_HW_Base.getIntPGM(RT_HW_PGM_PIN_INP_ID,0);
pinButton   =RT_HW_Base.getIntPGM(RT_HW_PGM_PIN_INP_ID,2);
pinPWM      =RT_HW_Base.getIntPGM(RT_HW_PGM_PIN_OUT_ID,0);
pinLed      =RT_HW_Base.getIntPGM(RT_HW_PGM_PIN_OUT_ID,2);
pinSPI_595  =RT_HW_Base.getIntPGM(RT_HW_PGM_PIN_CSS_ID,0);
pinSPI_lcd  =RT_HW_Base.getIntPGM(RT_HW_PGM_PIN_CSS_ID,1);
//---------------Адреса устройств.i2c--------------------------------------------------------------
i2c_lcd1=RT_HW_Base.getIntPGM(RT_HW_PGM_ADR_I2C_ID,0);
i2c_lcd2=RT_HW_Base.getIntPGM(RT_HW_PGM_ADR_I2C_ID,1);
i2c_mcp1=RT_HW_Base.getIntPGM(RT_HW_PGM_ADR_I2C_ID,2);
i2c_mcp2=RT_HW_Base.getIntPGM(RT_HW_PGM_ADR_I2C_ID,3);
//-------------------------------------------------------------------------------------------------
in0=1;
}   //--END  if(vInit == 0) 
                          
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//        1.ДИСПЕТЧЕР И КОНСОЛЬ ->вызываются в каждом цикле loop()
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//----1.1.Вызов диспетчера-------------------------------------------------------------------------
RT_HW_Base.sheduler();
//----1.2.Присвоение номеров задач-----------------------------------------------------------------
numQuick=RT_HW_Base.shed.quick.num; 
numFast =RT_HW_Base.shed.fast.num;  
numSlow =RT_HW_Base.shed.slow.num;  
numBack =RT_HW_Base.shed.back.num;
numFrdm =RT_HW_Base.shed.frdm.num;                                    
//----1.3.Инициализация консоли--------------------------------------------------------------------
RT_HW_Base.printBegin(115200); headConsole=RT_HW_Base.console.head;   //--Подключение консоли;
//----1.4.Вывод контрольный пин сигнала loop()-----------------------------------------------------
if(idControl.dir==0) {RT_HW_Base.setPinID(idControl,pinControl,RT_HW_PGM_PIN_DOT_ID,'N');} RT_HW_Base.pinDigitalWrite(idControl,bitRead(RT_HW_Base.shed.blink,0));                    
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//        2.ВЫВОД ПАРАМЕТРОВ (однократный вывод после готовности консоли параметров headConsole)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if(headConsole) {RT_HW_Base.console.resetHead=1;
for(uint8_t i=0; i<3; i++){RT_HW_Base.printCR();}
RT_HW_Base.printTextStr(String(F("Тест RT_HW_NEXT.h")),80,'C','=','Y'); 
//-----------------------------------------------------------------------------------
RT_HW_Base.printTextStr(String(F("Параметры платы")),  80,'C','-','Y'); 
RT_HW_Base.printNameBoard();      //--Вывод наименование платы;
RT_HW_Base.printParamBoard();     //--Вывод параметров платы;    
RT_HW_Base.printDepthBoard();     //--Вывод разрядности устройств(SYS,ADC,PWM,DAC,TCH)  
RT_HW_Base.printNamePins();       //--Вывод наименования пинов (ESP8266,ESP32);
//-----------------------------------------------------------------------------------
RT_HW_Base.printTextStr(String(F("Параметры интерфейсов")),  80,'C','-','Y'); 
RT_HW_Base.printParamWire();      //--Вывод параметров i2c;
RT_HW_Base.printParamSPI();       //--Вывод параметров SPI;
RT_HW_Base.printParamUART();      //--Вывод параметров UART;
//-----------------------------------------------------------------------------------
RT_HW_Base.printTextStr(String(F("Доступные пины платы")),80,'C','-','Y'); RT_HW_Base.printPinsBoard('P'); 
RT_HW_Base.printTextStr(String(F("Тестовые  пины платы")),80,'C','-','Y'); RT_HW_Base.printPinsTest ('P'); 
RT_HW_Base.printTextStr(String(F("Тестовые i2c адреса устройств")),80,'C','-','Y'); RT_HW_Base.printAdrTest('S');
//-----------------------------------------------------------------------------------
RT_HW_Base.printTextStr(String(F("Используемые пины и устройства")),80,'C','-','Y');
RT_HW_Base.printTextStr(String(F("Пины:контроль,led_Board,кнопка,светодиод")),50,'L','s',':'); RT_HW_Base.print_v8('D',0,'Y',3,(int8_t)pinControl,(int8_t)pinLedBoard,(int8_t)pinButton);
RT_HW_Base.printTextStr(String(F("Адреса i2c:lcd1,lcd2,mcp1,mcp2")),50,'L', 's', ':'); 
RT_HW_Base.print_v8('D',0,'Y',4,(int8_t)RT_HW_Base.getIntPGM(RT_HW_PGM_ADR_I2C_ID,0), RT_HW_Base.getIntPGM(RT_HW_PGM_ADR_I2C_ID,1),
                                        RT_HW_Base.getIntPGM(RT_HW_PGM_ADR_I2C_ID,2), RT_HW_Base.getIntPGM(RT_HW_PGM_ADR_I2C_ID,3));
//-----------------------------------------------------------------------------------
RT_HW_Base.printTextStr(String(F("Сканирование шины i2c")),80,'C','-','Y'); RT_HW_Base.scanDeviceWire(0); 
//----------------------------------------------------------------------------------
RT_HW_Base.printBlank(80,'-','Y');            //--Вывод горизонтальной линии;
//-------------------------------------------------------------------------------------------------
} 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//        3.ТЕСТОВЫЙ ВЫВОД МАССИВОВ Nextion
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if(numSlow==1){
if((okNext==0) && RT_HW_Base.console.mess){okNext=1; 
for(uint8_t i=0; i<3; i++){RT_HW_Base.printCR();}
RT_HW_Base.printTextStr(String(F("Вывод тестовых массивов для работы с lib. RT_HW_NEXT.h")),80,'C','=','Y'); 
okTest=1;               //--OkTest=0-упрощенный вывод; =1-дополнительный вывод; 
initID_Next(okTest);    //--Инициализация ID. Если параметр=1, дополнительный вывод на консоль. 
testArr_Next();         //--Вывод массивов, изменением массивов, вывод измененных массивов.                                     
//---------------------------------------------------------------
}} //--END if(numSlow==1)
//================================================================================================
} //--END lopp()     
//=================================================================================================
