#include "RT_HW_NEXT.h"
#include "RT_HW_NEXT_LIB.hpp"		//--Функции работы с зарезервированными массивами
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//		1.0.Конструктор
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RT_HW_NEXT:: RT_HW_NEXT(){
//---Заполнение указателей ссылкой на непустое устройство;
for(int8_t i=0; i<=RT_HW_NEXT_MAX_DEVICE;i++){
	ptr[i]=&zN; 
	ptr[i]->num=0; 
	ptr[i]->uart=-1;
	ptr[i]->ban=ptr[i]->permit=ptr[i]->ready=0;
	ptr[i]->lenArrByte=sizeof(hive.arrByte)/1; ptr[i]->ptrArrByte=hive.arrByte;
	ptr[i]->lenArrWord=sizeof(hive.arrWord)/2; ptr[i]->ptrArrWord=hive.arrWord;   
	ptr[i]->lenArrLong=sizeof(hive.arrLong)/4; ptr[i]->ptrArrLong=hive.arrLong;
	} 
	ptr[0]->ban=1;				//--Для устройства с номером 0 "Запрет на работу с устройством";
	hive.set=0x01; hive.qnt=0;};
										
//*************************************************************************************************
//		Функции для работы с устройством										
//*************************************************************************************************												
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//		2.1.Генератор событий
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void RT_HW_NEXT:: deviceGen(RT_HW_NEXT_DEVICE_ID &z){z.eventPeriod=z.eventReboot=0;
	if(RT_HW_Base.period(z.timeStart,RT_HW_MILLIS,RT_HW_NEXT_PERIOD_BLINK)){z.blink=!z.blink;             z.eventPeriod=1; 
		                                               if(++z.cntReboot>20){z.blinkReboot=!z.blinkReboot; z.eventReboot=1; z.cntReboot=1;}}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		2.2.Установка параметров
//	1.Поиск первого свободного указателя и привязка к нему устройства (от 1 до RT_HW_NEXT_MAX_DEVICE);
//	2.Установка флага готовности устройства z.permit=1, если обнаружено и привязано свободное устройство;
//  3.Если свободные указатели отсутствуют, то: 1.установка z.ban=1; 2.номер устройства устанавливается =0;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_NEXT:: deviceSetID(RT_HW_NEXT_DEVICE_ID &z, int8_t  uart, uint32_t speed,uint8_t *arrByte,uint16_t *arrWord, uint32_t *arrLong, 
                                             uint8_t lenArrByte,uint8_t lenArrWord, uint8_t lenArrLong){
if(z.dir!=0) {return;} //--Для исключения повторной инициализации;
z.ban=z.permit=z.ready=0;	z.num=z.dir=z.cntPack=0;	//--Очистка регистров;
z.cntMax=2;										//--Ограничение кол-ва одновременно отправляемых посылок. Может быть изменен при настройке.
z.lenArrByte=lenArrByte/1;z.ptrArrByte=arrByte; //--Сохранение размера и указателя 1-го байтового массива под переменные;  
z.lenArrWord=lenArrWord/2;z.ptrArrWord=arrWord; //--Сохранение размера и указателя 2-го байтового массива под переменные;    
z.lenArrLong=lenArrLong/4;z.ptrArrLong=arrLong; //--Сохранение размера и указателя 4-го байтового массива под переменные;   
z.speed=speed;									//--Сохранение скорости UART;								 
if(RT_HW_Base.uartCheckNum(uart)){z.uart=uart;}	else {z.uart=-1; z.ban=1; z.num=0;}	//--Проверка допустимости номера uart;
if(!z.ban){for(uint8_t i=0; i<=RT_HW_NEXT_MAX_DEVICE; i++){if(!bitRead(hive.set,i)) //--Поиск первого
	     {bitSet(hive.set,i); z.num=i; z.permit=1; hive.qnt++; ptr[i]=&z; break;}}}	//  		свободного устройства;
if(!z.permit) {z.ban=1; z.num=0;}													//--Если устройство не найдено, то флаг блокировки;
if(z.permit) {z.dir=1;} else {z.dir=7;} 											//--Если успешно->z.dir=1; иначе z.dir=7;
//-------------------------------------------------------------------------------------------------
};	//--END	deviceSetID()
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	2.3.Управление устройством
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_NEXT:: deviceDirect (RT_HW_NEXT_DEVICE_ID &z){	
if(z.dir==3){
//-----------------------------------------------------------------------------
//	Ожидание начала посылки(=0x3A)
//-----------------------------------------------------------------------------
if(z.readUartState==0) {
	while(RT_HW_Base.uartAvailable(z.uart)>0) {z.readUartTimeStart=RT_HW_MILLIS;
	if(RT_HW_Base.uartRead(z.uart)==0x3A) {z.readUartHead=0x3A; z.readUartErr=0; z.readUartPack++; z.readUartState++; break;}}
	if(z.readUartState==0) {return;}
#ifdef	RT_HW_NEXT_DEBUG	
	RT_HW_Base.printCR(); RT_HW_Base.printTxt(String(F("Begin pack num="))); RT_HW_Base.printVal('H', 2, ' ',z.readUartPack); RT_HW_Base.printVal('H', 2, ' ',z.readUartHead);
#endif
}
//-----------------------------------------------------------------------------
//	Ожидание кода функции; Выход по ошибке, если функция не верна; 
//-----------------------------------------------------------------------------
if(z.readUartState==1) {if(RT_HW_Base.uartAvailable(z.uart)==0) {return;}
	z.readUartFunc=RT_HW_Base.uartRead(z.uart); 
	if((z.readUartFunc==0x06) || (z.readUartFunc==0x16) || (z.readUartFunc==0x26)){
#ifdef	RT_HW_NEXT_DEBUG				
	RT_HW_Base.printVal('H', 2, ' ',z.readUartFunc);
#endif		
	z.readUartState++;}
	else {z.readUartErr=1; 
#ifdef	RT_HW_NEXT_DEBUG				
	RT_HW_Base.printTxt(String(F(" err="))); RT_HW_Base.printVal('H', 2, ' ',z.readUartErr);
#endif	
	z.readUartState=0;  return;}		//--Выход по ошибке кода функции;
}
//-----------------------------------------------------------------------------	
//	Ожидание адреса 1-го регистра;
//-----------------------------------------------------------------------------
if(z.readUartState==2) {if(RT_HW_Base.uartAvailable(z.uart)==0) {return;}
	z.readUartAdr=RT_HW_Base.uartRead(z.uart); z.readUartState++;
#ifdef	RT_HW_NEXT_DEBUG	
	RT_HW_Base.printVal('H', 2, ' ',z.readUartAdr);	
#endif		
}
//-----------------------------------------------------------------------------	
//	Ожидание кол-во принимаемых регистров; Вычисление кол-во принимаемых байт;
//-----------------------------------------------------------------------------		
if(z.readUartState==3) {if(RT_HW_Base.uartAvailable(z.uart)==0) {return;}
	z.readUartQntReg=RT_HW_Base.uartRead(z.uart); 
	if(z.readUartFunc==0x06) {z.readUartQntByte=z.readUartQntReg;   if((z.readUartAdr+z.readUartQntByte)> z.lenArrByte)    {z.readUartErr=2;}}
	if(z.readUartFunc==0x16) {z.readUartQntByte=z.readUartQntReg*2; if((z.readUartAdr+z.readUartQntByte)>(z.lenArrWord*2)) {z.readUartErr=3;}}
	if(z.readUartFunc==0x26) {z.readUartQntByte=z.readUartQntReg*4; if((z.readUartAdr+z.readUartQntByte)>(z.lenArrLong*4)) {z.readUartErr=4;}}
	if(z.readUartQntByte>RT_HW_NEXT_BUFF_REG_SIZE)                                                                         {z.readUartErr=5;}
	if(z.readUartErr>0){
#ifdef	RT_HW_NEXT_DEBUG			
	RT_HW_Base.printTxt(String(F(" err="))); RT_HW_Base.printVal('H', 2, ' ',z.readUartErr); 
#endif		
						 z.readUartState=0; return;}
#ifdef	RT_HW_NEXT_DEBUG							 
	RT_HW_Base.printVal('H', 2, ' ',z.readUartQntReg);
#endif	
	z.readBuffIndex=0; //z.readBuffCnt=z.readBuffQnt;
z.readUartState++;}	
//-----------------------------------------------------------------------------
//	Ожидание приема приема байтов данными 
//-----------------------------------------------------------------------------
if(z.readUartState==4) {
	while(1){if(RT_HW_Base.uartAvailable(z.uart)==0) {return;}
			 z.readBuffByte[z.readBuffIndex]=RT_HW_Base.uartRead(z.uart); 
#ifdef	RT_HW_NEXT_DEBUG		
	RT_HW_Base.printVal('H', 2, ' ',z.readBuffByte[z.readBuffIndex]);
#endif		
			if(++z.readBuffIndex>=z.readUartQntByte) {break;}
			}	
z.readUartState++;}	
//-----------------------------------------------------------------------------		
//	Ожидание приема контрольной суммы
//-----------------------------------------------------------------------------
if(z.readUartState==5) {if(RT_HW_Base.uartAvailable(z.uart)==0) {return;}
	z.readUartCRC=RT_HW_Base.uartRead(z.uart); 
#ifdef	RT_HW_NEXT_DEBUG	
	RT_HW_Base.printVal('H', 2, ' ',z.readUartCRC);
#endif
z.readUartState++;}
//-----------------------------------------------------------------------------	
//	Расчет контрольной суммы и сравнение с принятой контрольной суммой
//-----------------------------------------------------------------------------
if(z.readUartState==6) { 
	z.readBuffCRC =z.readUartHead; 
	z.readBuffCRC+=z.readUartFunc; 
	z.readBuffCRC+=z.readUartAdr; 
	z.readBuffCRC+=z.readUartQntReg;
	for(uint8_t i=0; i<z.readUartQntByte; i++){z.readBuffCRC+=z.readBuffByte[i];}
	z.readBuffCRC=0xFF-z.readBuffCRC; z.readBuffCRC++;
#ifdef	RT_HW_NEXT_DEBUG	
	RT_HW_Base.printTxt(String(F("crc="))); RT_HW_Base.printVal('H', 2,' ',z.readBuffCRC);
#endif	
	if(z.readUartCRC!=z.readBuffCRC){z.readUartErr=6;}
	if(z.readUartErr>0){ 
#ifdef	RT_HW_NEXT_DEBUG	
	RT_HW_Base.printTxt(String(F(" err="))); RT_HW_Base.printVal('H', 2, ' ',z.readUartErr); 
#endif	
						 z.readUartState=0; return;}
	z.readUartState++;}					 
//-----------------------------------------------------------------------------	
//	Запись принятых данных в соответствующие массивы
//-----------------------------------------------------------------------------
if(z.readUartState==7){
	for(uint8_t i=0; i<z.readUartQntReg;i++){
		if(z.readUartFunc==0x06) {uint8_t  buff8=0;  buff8 = z.readBuffByte[i]; 
										             setValArr(z.num,'B',(z.readUartAdr+i),buff8);}
		if(z.readUartFunc==0x16) {uint16_t buff16=0; buff16=(z.readBuffByte[i*2+1]<<8)+z.readBuffByte[i*2];    
										             setValArr(z.num,'W',(z.readUartAdr+i),buff16);}
		if(z.readUartFunc==0x26) {uint32_t buff32=0; buff32=(z.readBuffByte[i*4+3]<<8)+z.readBuffByte[i*4+2];
									                 buff32<<=8; buff32<<=8;
									                 buff32+=((z.readBuffByte[i*4+1]<<8)+z.readBuffByte[i*4]);  
									              i+=3; setValArr(z.num,'L',(z.readUartAdr+i),buff32);}
									         }								   
#ifdef	RT_HW_NEXT_DEBUG	
if(z.readUartFunc==0x06) {RT_HW_Base.printTxt(String(F(" dataByte len="))); RT_HW_Base.printVal('H', 2,',',z.lenArrByte); 
						  RT_HW_Base.printTxt(String(F(" func="))); RT_HW_Base.printVal('H', 2,',',z.readUartFunc);
						  RT_HW_Base.printTxt(String(F(" adr="))); RT_HW_Base.printVal('H', 2,',',z.readUartAdr);
						  RT_HW_Base.printTxt(String(F("qntReg="))); RT_HW_Base.printVal('H', 2,' ',z.readUartQntReg);  
						  RT_HW_Base.printChar('-','>');
						  for(uint8_t i=0; i<z.readUartQntReg;i++){RT_HW_Base.printVal('H',2,' ',getValArr (z.num,'B',(z.readUartAdr+i)));}
						  //RT_HW_Base.printCR(); 
						  //for(uint8_t i=0;    i<0x10; i++){RT_HW_Base.printVal('H',2,' ',getValArr (z.num,'B',i));}
						  //RT_HW_Base.printChar('-'); 
						  //for(uint8_t i=0x10; i<0x20; i++){RT_HW_Base.printVal('H',2,' ',getValArr (z.num,'B',i));}
						  }
#endif	
z.readUartState=0;}
//-----------------------------------------------------------------------------
}	//--END if(z.dir==3)


//--Основной цикл работы; 	
if(z.dir==1){RT_HW_Base.uartBegin(z.uart,z.speed); z.dir=2; return;}		//--Инициализация UART;		  
if(z.dir==2){if(RT_HW_Base.uartSerial(z.uart))  {z.ready=1; z.dir=3;}} 		//--Ожидание готовности UART;
};	//--END	deviceDirect()
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	2.4.Проверка запрета вывода по ограничению кол-ва транзакций в устройство в одном цикле.
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool RT_HW_NEXT:: deviceLimitPack (uint8_t num){if(ptr[num]->cntPack < ptr[num]->cntMax) {++ptr[num]->cntPack; return 0;} return 1;};   	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	2.5. Функция отправки команды в устройство
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_NEXT:: deviceCmndToNext(uint8_t uart, String &cmnd){RT_HW_Base.uartPrint(uart,cmnd);								
for(uint8_t i=0;i<3;i++){RT_HW_Base.uartWrite(uart,0XFF);}};										   
//*************************************************************************************************
//		Функции для работы с блоками записи в дисплей										
//*************************************************************************************************	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	3.1.Генератор событий
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_NEXT:: writeGen(RT_HW_NEXT_DIRECT_ID &id){id.eventPeriod=id.eventReboot=0;
if(id.agoBlink!=getBlink(id.num)){id.agoBlink=getBlink(id.num);			
if(++id.cntEvent >id.periodEvent) {id.cntEvent=1;  id.eventPeriod=1; if(++id.cntReboot>id.periodReboot){id.cntReboot=1; id.eventReboot=1; }}}};			  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	3.2.Инициализация ID для вывода параметровж;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_NEXT:: writeSetID (RT_HW_NEXT_DIRECT_ID &id, uint8_t num, uint16_t periodWriteVal, uint16_t periodWriteRpt){
if(id.dir!=0) 			{return;} //--Ничего не делаем, если блок уже настроен;
if(num==0)    			{return;} //--Для того, чтобы дождаться, когда управляющий блок установит номер устройства;
if(!ptr[num]->permit) 	{return;} //--Выход, если устройство не готово;
id.num=num;	
id.uart=getNumUart(id.num);
id.periodEvent=25; 
id.periodReboot=3;   
id.cntEvent=id.cntReboot=0; 
id.firstWrite=1;
id.periodWriteVal=periodWriteVal;  
id.periodWriteRpt=periodWriteRpt;
id.timeWriteVal=id.timeWriteRpt=RT_HW_MILLIS;	
id.dir=1;
}; //--END writeSetID() 

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	3.2.Инициализация ID для вывода параметровж;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_NEXT:: writeDirect (RT_HW_NEXT_DIRECT_ID &id, uint8_t adr, int32_t val){
if(id.dir==1){id.checkVal=id.eventWriteVal=id.eventWriteRpt=0;
	if(id.periodWriteVal>0)    {if(RT_HW_MILLIS>=(id.timeWriteVal+id.periodWriteVal)){id.checkVal=1;     id.timeWriteVal=RT_HW_MILLIS;}} else {id.checkVal=1;} 
	if(id.periodWriteRpt>=1000){if(RT_HW_MILLIS>=(id.timeWriteRpt+id.periodWriteRpt)){id.eventWriteRpt=1;id.timeWriteRpt=RT_HW_MILLIS;}}} 
    if(id.checkVal) {if(id.ago!=val) {id.eventWriteVal=1;}}
	if(id.eventWriteVal || id.eventWriteRpt || id.firstWrite) {id.firstWrite=0; id.ago=val;  id.dir=2;} else {return;}
if(id.dir==2) { deviceLimitPack(id.num); //) {return;}
			    if(RT_HW_Base.uartAvailableForWrite(id.num)<20) {return;}
				String cmnd=String(F("in")) +String(adr)+String("=") + String(id.ago); //--Формирование команды;
 //           Serial.print(String(" cnt=")+String(ptr[id.num]->cntPack)+String(" sz=") 
//			+String(RT_HW_Base.uartAvailableForWrite(id.num))+String("-->")+String(cmnd)); Serial.println(" *** ");
                deviceCmndToNext(id.uart, cmnd); //--Записю в устройство команды с завершающими символами;
				id.dir=1;}
                 
}; //--END writeSetID() 






//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
RT_HW_NEXT RT_HW_Next;	//Создание внешнего объекта	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		Запись параметров устройства
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool RT_HW_NEXT:: checkDevice(int8_t num){
	if((num>RT_HW_NEXT_MAX_DEVICE) || (num<=0)) {return 0;} 
	if(ptr[num]->ban) 		{return 0;} 
	if(ptr[num]->permit) 	{return 1;} 
							 return 0;}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		Модифицированное чтение флага "Запрет использования устройства"
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++							 
bool RT_HW_NEXT:: makeBan(int8_t num, int8_t val){
if(!checkDevice(num)){return 1;} 
if(val==0) {ptr[num]->ban=0;}    
if(val==1) {ptr[num]->ban=1;}    
return ptr[num]->ban;}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		Модифицированное чтение флага "Разрешение использования устройства"
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
bool RT_HW_NEXT:: makePermit(int8_t num, int8_t val){
if(!checkDevice(num)){return 0;} 
if(val==0) {ptr[num]->permit=0;} 
if(val==1) {ptr[num]->permit=1;} 
return ptr[num]->permit;}	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		Получение адреса указателя на устройство (для отладки)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint32_t RT_HW_NEXT:: getPtrDev(int8_t num){
if(!checkDevice(num)) {return (uint32_t)ptr[0];} 
return (uint32_t)ptr[num];};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		Получение адреса указателя на массив
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint32_t RT_HW_NEXT:: getPtrArr(int8_t num, char mode){
if(!checkDevice(num)) {return (uint32_t)ptr[0];}
if(mode=='B'){return (uint32_t)ptr[num]->ptrArrByte;}
if(mode=='W'){return (uint32_t)ptr[num]->ptrArrWord;}
if(mode=='L'){return (uint32_t)ptr[num]->ptrArrLong;} 
return 0;}	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//     Получение длины массива
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t  RT_HW_NEXT:: getLenArr(int8_t num, char mode){
if(!checkDevice(num)) {return 0;}
if(mode=='B'){return ptr[num]->lenArrByte;}
if(mode=='W'){return ptr[num]->lenArrWord;}
if(mode=='L'){return ptr[num]->lenArrLong;} return 0;}

*/





//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  Запись параметров устройства
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//void RT_HW_NEXT:: setArrByte(uint8_t num, uint8_t index, uint8_t val){val=num;};


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//		Инициализация устройства;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//void RT_HW_NEXT:: setDeviceID(RT_HW_NEXT_DEVICE_ID &id, int8_t num, uint32_t speed){
//if(id.custom) {return;} id.custom=1; 
//id.permit=id.ban=id.busy=0; 
//id.cntSend=id.cntReceive=0;
//id.stepInit=id.dir=0;
//id.num=num; id.speed=speed;
//if(!RT_HW_Base.checkNumUART(num)) {id.ban=1; return;}
//} 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//		Завершающая посылка;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//void RT_HW_NEXT:: sendEnd(RT_HW_NEXT_DEVICE_ID &id){for(uint8_t //i=0;i<3;i++){RT_HW_Base.uartWrite(id.num,0XFF);}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//		Инициализация параметров устройства;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//void RT_HW_NEXT:: init(RT_HW_NEXT_DEVICE_ID &id){
/*
if(id.permit) {return;}
if(id.ban)	  {return;}
//----Установка скорости и параметров UART;
if(id.stepInit==0) {RT_HW_Base.uartBegin(id.num, id.speed); id.stepInit++;}
//----Ожидание готовности UART;
if(id.stepInit==1) {if(RT_HW_Base.uartSerial(id.num)) {id.stepInit++;} else {return;}}
//----Отправка пустой команды (0xFF, 0xFF, 0xFF);
if(id.stepInit==2) {id.timeStart=RT_HW_MILLIS; RT_HW_Base.uartPrint(id.num,""); sendEnd(id); id.stepInit++;}
//----Повторная отправка пустой команды (0xFF, 0xFF, 0xFF) через 50мс;
if(id.stepInit==3) {if(RT_HW_Base.getPastMs(id.timeStart)<50) {return;}	
					id.timeStart=RT_HW_MILLIS; RT_HW_Base.uartPrint(id.num,""); sendEnd(id); id.stepInit++;}
//----Повторная отправка пустой команды (0xFF, 0xFF, 0xFF) через 50мс;					
if(id.stepInit==4) {if(RT_HW_Base.getPastMs(id.timeStart)<50) {return;}	
					id.timeStart=RT_HW_MILLIS; RT_HW_Base.uartPrint(id.num,""); sendEnd(id); id.stepInit++;}
//----Отправка команды 
if(id.stepInit==5) {if(RT_HW_Base.getPastMs(id.timeStart)<50) {return;}	
					id.timeStart=RT_HW_MILLIS;
					id.cmnd="bkcmd=1";
					Serial1.print(id.cmnd);
					//RT_HW_Base.uartPrint(id.num,id.buffSend); 
					sendEnd(id); id.stepInit++;}
if(id.stepInit==6) {if(RT_HW_Base.getPastMs(id.timeStart)<50) {return;}	
					id.timeStart=RT_HW_MILLIS;
					id.cmnd="";
					id.cmnd +="dhtT";
					id.cmnd +=".txt=\"";
					id.cmnd += "27.68";
					id.cmnd += "\"";
					RT_HW_Base.uartPrint(id.num,id.cmnd); sendEnd(id); id.stepInit++;}										
if(id.stepInit==7) {id.permit=1;
					//Serial.println(F("NextInit step=6"));
					id.stepInit=100;
					}	

 // String cmd;
 //   cmd += getObjName();
 //   cmd += ".txt=\"";
 //   cmd += buffer;
 //   cmd += "\"";
 //   sendCommand(cmd.c_str());
*/					
//}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//		Инициализация параметров устройства;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//void RT_HW_NEXT:: setTxtID (RT_HW_NEXT_TXT_ID &id, uint16_t period){if(id.dir==0){id.dir=1;	}};

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//		Инициализация устройства;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//bool RT_HW_NEXT:: nexInit(void){
//bool ret1 = false;
//bool ret2 = false;
//dbSerialBegin(9600);
//nexSerial.begin(9600);
//sendCommand("");
//sendCommand("bkcmd=1");
//ret1 = recvRetCommandFinished();
//sendCommand("page 0");
//ret2 = recvRetCommandFinished();
//   return ret1 && ret2;
// }
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//		Инициализация устройства;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
//void RT_HW_NEXT:: sendCommand(const char* cmd){
//while (nexSerial.available()){nexSerial.read();}
//nexSerial.print(cmd);
//nexSerial.write(0xFF);
//nexSerial.write(0xFF);
//nexSerial.write(0xFF);
//} 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//		Инициализация устройства;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//bool  RT_HW_NEXT::recvRetCommandFinished(uint32_t timeout){bool ret = false; uint8_t temp[4] = {0};
//nexSerial.setTimeout(timeout);
//if (sizeof(temp) != nexSerial.readBytes((char *)temp, sizeof(temp))) {ret = false;}
//if((temp[0]==NEX_RET_CMD_FINISHED)&&(temp[1]==0xFF)&&(temp[2]==0xFF)&&(temp[3]==0xFF)){ret=true;}
//if (ret){dbSerialPrintln("recvRetCommandFinished ok");}
//else	{dbSerialPrintln("recvRetCommandFinished err");}
//return ret;}
 
 




