/**************************************************************************************************
 *       БИБЛИОТЕКА ДЛЯ РАБОТЫ С ДИСПЛЕЯМИ NEXTION
 *************************************************************************************************/
#ifndef RT_HW_NEXT_h
#define RT_HW_NEXT_h
//-------------------------------------------------------------------------------------------------
#include "RT_HW_BASE.h"						//--Подключение базовой библиотеки;
#define RT_HW_NEXT_VER			010			//--Номер версии библиотеки;
#define RT_HW_NEXT_VER_NAME		0.1.0		//--Имя номера версии библиотеки;
#define RT_HW_NEXT_MAX_DEVICE	8
#define RT_HW_NEXT_PERIOD_BLINK 50			//--Период тиков для 
#define RT_HW_NEXT_TIMEOUT_READ 100			//--Тайм-аут на принятие посылки;
#define RT_HW_NEXT_BUFF_REG_SIZE 32			//--Тайм-аут на принятие посылки;
//#define RT_HW_NEXT_DEBUG
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	Коды параметров
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		ПЕРЕЧИСЛЕНИЯ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
enum{RT_HW_NEXT_PARAM_BLINK=0, RT_HW_NEXT_PARAM_NUM, RT_HW_NEXT_PARAM_UART, RT_HW_NEXT_PARAM_STATE};
enum{RT_HW_NEXT_STATE_NOT_INIT=0, RT_HW_NEXT_STATE_BAN, RT_HW_NEXT_STATE_PERMIT, RT_HW_NEXT_STATE_READY, RT_HW_NEXT_STATE_BUSY};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		Структура данных для каждого устройства - 
//			все данные хранятся в массиве RT_HW_NEXT_DEVICE_ID *ptr[RT_HW_NEXT_MAX_DEVICE+1],
//			создаваемом при создании класса RT_HW_NEXT.
//	statе - состоние устройства;
//	=RT_HW_NEXT_STATE_NOT_INIT(=0)-устройство не инициализировано. По этом условию вызвается функция инциализации;
//	=RT_HW_NEXT_STATE_BAN	  (=1)-устройство после инициализации заблокировано (недопустимая совокупность условий и параметров);
//	=RT_HW_NEXT_STATE_PERMIT  (=2)-устройство после инициализации  готово дальнейшей настройки(UART и пр.);
//  =RT_HW_NEXT_STATE_READY   (=3)-устройство инициализировано, UART настроен и готов к обмену данными; 
//  =RT_HW_NEXT_STATE_BUSY    (=4)-устройство занято отправкой транзакций. 
//    Переводится из RT_HW_NEXT_STATE_READY в RT_HW_NEXT_STATE_BUSY специальной функцией, если число транзакций за один вход
//	  в задачу (для FLProg это плата) превышает заданное кол-во (например 3). Это делается для снижение вероятности переполнения
//	  кольцевого буферa UART и снижения временных задержек от задачи.
//	  В рабочем режиме при входе в задачу состояние всегда сбрасывается в RT_HW_NEXT_STATE_READY.  
//	num - уникальный номер устройства, назначаемый при инциализации (от 1 до RT_HW_NEXT_MAX_DEVICE(default=8).
//		  Если при инциализации выявляется недопустимая совокупность условий и параметров (недопустимый uart, все номера заняты и пр.),
//		  параметру присвативается значение =0;
//	uart,speed-номер и скорость настройки выбранного UART;
//  blink-битовое периодически(default=50mc) меняющий значение параметр;
//  Blink-битовое периодически(каждые 20 раз ао счетчику Cnt(максиум=63) при смене blink->default=1000mc) меняющий значение параметр; 
//  event - событие по изменению blink;
//	Event - событие по изменени  Blink;
//  dir   - номер этапа для функции управления устройтством.
//  cntPack-Счетчик отправленных кол-во пакетов за одно вхождение в задачу; и его ограничение;
//  cntNax -Ограничение кол-во пакетов, отправленных за одно вхождение в задачу;
//  err   - код ошибки (0-7) при работе с устройством
//  *** Примечание. Все параметры инициализируются конструктором.
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct  RT_HW_NEXT_DEVICE_ID {  		   
uint8_t	 state, num, dir;					//--Номер устройства (номер=0 - резервный),номер UART;
 int8_t	 uart;								//--Номер UART;
uint32_t speed;								//--Скорость UART;
uint32_t timeStart; 						//--Переменные для работы со временем;
uint8_t  blink:1, eventPeriod:1, blinkReboot:1, eventReboot:1, ban:1, permit:1, ready:1, busy:1; 
uint8_t  cntReboot; 
uint8_t  cntPack:4, cntMax:4;				//--Счетчик отправленных кол-во пакетов за одно вхождение в задачу и его ограничение;
uint8_t  lenArrByte,lenArrWord,lenArrLong;	//--Размер массивов uint8_t arrByte[], uint16_t arrWord[], uint8_t arrLong[]; 
uint8_t	 *ptrArrByte;						//--Указатель на массив uint8_t  arrByte[];
uint16_t *ptrArrWord;						//--Указатель на массив uint16_t arrWord[];
uint32_t *ptrArrLong;						//--Указатель на массив uint32_t arrLong[];

//uint8_t  readLenPack;
//uint8_t  readHeadUart; 		//--Заголовок принимаемой посылки
//uint8_t  readFuncUart; 		//--Функция записи регистров: 6-uint8_t, 16-uint16_t, 26-uint32_t
//uint8_t  readAdrUart;   	//--Адрес 1-го регистра соответствующего буфера;
//uint8_t  readQntUart;    	//--Кол-во регистров;
//uint8_t  readCrcUart;    	//--Контрольная суммы;
uint8_t  readUartState;
uint8_t  readUartErr;
uint8_t  readUartPack;
uint8_t  readUartBuff;
uint8_t  readUartHead;
uint8_t  readUartFunc;
uint8_t  readUartAdr;
uint8_t	 readUartQntReg;
uint8_t  readUartQntByte;
uint8_t	 readUartCRC;	
uint32_t readUartTimeStart;
uint8_t  readBuffHead[5];						//--Буфер для служебной посылки->head,func,adr,qnt,crc

uint8_t  readBuffByte[RT_HW_NEXT_BUFF_REG_SIZE];	//--Буферы для приема значащих регистров;
uint8_t  readBuffIndex;							//--Индекс для работы с буферами
uint8_t  readBuffCRC;
uint8_t  readBuffQnt;
uint8_t  readBuffCnt;

//uint8_t  readQntUart;
//uint32_t readTimeOutStart;

};   
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	СТРУКТУРА RT_HW_NEXT_DEVICE_ID- параметры устройства ;	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct  RT_HW_NEXT_DIRECT_ID{   //--16 байт
uint8_t  num,uart,dir,agoBlink;
uint8_t  permit, eventPeriod, eventReboot, eventReady, change;
uint8_t  cntEvent,cntReboot;
uint8_t  periodEvent, periodReboot;
uint16_t cntSend;
uint16_t cntReceive;
uint8_t  eventWriteVal:1,  eventWriteRpt:1, checkVal:1, firstWrite:1;
uint16_t periodWriteVal,   periodWriteRpt;
uint32_t timeWriteVal,     timeWriteRpt;
int32_t  ago;			   
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                    Структура данных рабочих параметров
// set - флаги занятости устройства
// qnt - кол-во занятых устройств
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct RT_HW_NEXT_HIVE	{
uint16_t set;						//--Флаги занятости устройства 
uint8_t  qnt; 						//--Кол-во зарегистрированных устройств;
uint8_t  arrByte[2]={0,0};			//--1-байтовый массив для недопустимых устройств;
uint16_t arrWord[1]={0};			//--2-байтовый массив для недопустимых устройств;
uint32_t arrLong[1]={0};			//--4-байтовый массив для недопустимых устройств;
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		КЛАСС: RT_HW_NEXT
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class RT_HW_NEXT{
public:
//------Данные-------------------------------------------------------------------------------------
RT_HW_NEXT_HIVE	hive;								//--Общие данные для работы библиотеки;
RT_HW_NEXT_DEVICE_ID *ptr[RT_HW_NEXT_MAX_DEVICE+1];	//--Массив указателей на данные со структурой устройств;
RT_HW_NEXT_DEVICE_ID zN;							//--Данные для копирования в не инициализированные указатели;
//------Базовые методы-----------------------------------------------------------------------------
RT_HW_NEXT();										//--Конструктор;
//------Функции блока управления устройством-------------------------------------------------------	
void deviceSetID (RT_HW_NEXT_DEVICE_ID &z, int8_t  uart, uint32_t speed,uint8_t *arrByte,uint16_t *arrWord, uint32_t *arrLong, 
                  uint8_t lenArrByte,uint8_t lenArrWord, uint8_t lenArrLong);	//--Инициализация параметров;
void deviceGen   (RT_HW_NEXT_DEVICE_ID &z);			//--Генератор событий; 
void deviceDirect(RT_HW_NEXT_DEVICE_ID &z);			//--Управление устройством;
bool deviceLimitPack (uint8_t num);					//--Ограничение переполнения выходного буфера транзакциями;;
void deviceCmndToNext(uint8_t uart, String &cmnd);	//--Отправка команды в UART;
bool deviceCheckNum(uint8_t num);					//--Проверка наличия и доступности устройства;

//------Функции блоков управления записью---------------------------------------------------------	  
void writeSetID  (RT_HW_NEXT_DIRECT_ID &id, uint8_t num, uint16_t periodWriteVal, uint16_t periodWriteRpt);
void writeGen    (RT_HW_NEXT_DIRECT_ID &id);
void writeDirect (RT_HW_NEXT_DIRECT_ID &id, uint8_t adr, int32_t val);					

//------------------
bool	 getBlink     (uint8_t num){return ptr[num]->blink;};//--Возвращает значение тактового сигнала; 
int8_t	 getNumNext   (uint8_t num){return ptr[num]->num;}; //--Возвращает номер UART устройства с номером num (или -1);
int8_t	 getNumUart   (uint8_t num){return ptr[num]->uart;}; //--Возвращает номер UART устройства с номером num (или -1);
uint32_t getSpeedUART (uint8_t num);					//--Получение скорости устройства с номером num;
uint32_t getPtrDev    (uint8_t num);					//--Получение адреса указателя на устройство;
uint32_t getPtrArr    (uint8_t num, char mode);			//--Получение адреса указателя на массив;
uint8_t  getLenArr    (uint8_t num, char mode);			//--Получение длины массива;
uint32_t getValArr    (uint8_t num, char mode, uint8_t index);	//--Получение значение из массива;
void  	 setValArr    (uint8_t num, char mode, uint8_t index, uint32_t val);
//=================================================================================================
};  //---END 
//==============  Конец класса =====================================================================
extern RT_HW_NEXT RT_HW_Next; //--Создание объекта 
//===================================================================================
#endif //---RT_HW_NEXT_h



